#include "mydefs.h"
// #include "rat.h"
#include <string.h>

#define MOD(a,b) (((a)%(b)+(b))%(b))

 
int nstring(int *s, int len)
// nr of strings of braid word s
{
   int l=0;

   while(len-- >0)
   { if(abs(*s)>l) l=abs(*s);
     s++;
   }

   ret l+1;
}

int p=0,*arx,*ary;
// arx & ary - arrays to fill x & y coords of plane curve
// p - nr of entries in arx & ary

void store(const int x,const int y)
{
  arx[p]=x; ary[p++]=y;
}
  
void reduce() // const int x,const int y)
{
  for(int i=1;i<p-1;i++)
  {
    int *a=arx+i-1, *b=ary+i-1;  

  if( a[0]==a[1] && a[1]==a[2] || 
      a[0]+a[2]==2*a[1] && b[0]+b[2]==2*b[1] 
    )
    { 
      for(int j=i;j<p-1;j++) 
	 ary[j]=ary[j+1], arx[j]=arx[j+1];

      i--; p--;
    }
  }
}


void output(int *bword, int blen, ostream & o=cout)
{
   int n = nstring(bword,blen), // # strands
       arl=(blen+5)*n;

   arx=new int[arl];
   ary=new int[arl];

   int x=0,y=0;
   int l=0,i;

   int sg[2*blen],*s=sg;

   do
   {
     store(x,y);		// o<<x<<" "<<-y<<" "<<endl;

     if(abs(bword[y])==x) { x--,sg[l++]=-sgn(bword[y]); }
     else
     if(abs(bword[y])==x+1) { x++,sg[l++]=sgn(bword[y]); }
  
     if(++y==blen) // wrap around 
     {
       y=0;

       store(x,blen); 		// o<<x<<" "<<-blen<<endl;
       store(x,blen+x+1); 	// o<<x<<" "<<-blen-x-1<<endl;
       store(-x-2,blen+x+1); 	// o<<-x-2<<" "<<-blen-x-1<<endl;
       store(-x-2,-x-1); 	// o<<-x-2<<" "<<+x+1<<endl;
       store(x,-x-1); 		// o<<x<<" "<<+x+1<<endl;
       				// o<<endl;
     }
   }
   while(x||y);

   reduce();

   o<<p<<endl; // # vert
   
   for(i=0;i<p;i++)
     o<<arx[i]<<" "<<-ary[i]<<endl;

   delete [] arx,ary;

   if(l<2*blen)
   {
     cerr<<"no knot"<<endl;
     ret;
   }

   o<<x-1<<" "<<-blen/2<<endl; // braid axis
   o<<blen<<endl; // nr of crsg

   while(l-- >0)
   { o<<(*s++<0 ? '-' : '+' );
     if(l%60==0) o<<endl;
   }
}

main()
{
  int a,*b;

  while(cin>>a) {

  b=new int[a];

  char c;

   for(u_sh k=0;k<a;k++)
   { 
          do cin>>c; while(c!=(k?',':'{')); 
	  cin>>b[k];
   }
	  
   do cin>>c; while(c!='}');


  output(b,a);

  cout<<"% "<<a<<" ";
  outputarray(cout,b,a);
 }
}
