// This is a program by A.Stoimenow for computing the inv. of Th.Fiedler
// All after '//' & betw. '/*' and '*/' is a comment.
// Ask me (stoimeno@informatik.hu-berlin.de) for more explanations.
// THIS PROG IS CONSTANTLY UPDATED !!!

// #define NOTRC
// #define TEST
// #define TRC(a)
#define LINK
// #define TANGLE

#ifdef LINK
#define TANGLE
#endif

// #define BUNDLE

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mydefs.h"
#include "comp.h"
#include <iostream.h>
#include <fstream.h>
#include <malloc.h>
#include <stream.h>
#include <stdarg.h>
#include "_rat.h" 

#define MOD(a,b) (((a)%(b)+(b))%(b))

typedef Rat rat;


string pnm; // the prog name;

#define CERR cerr<<pnm<<": "
#define ERROR(a,r) if (a) { CERR<<r<<endl; exit(-1); }
#define PERROR(a,r) ERROR(a,"proj file format error: "<<r)

inline double atantopi(double y, double x)
{
  ret atan2(y,x)/atan2(0,-1);
}

inline int nrint(double x)
{
  ret int(x<0?floor(x+0.5):ceil(x-0.5));
}

class GD // Gauss diagram
{ public:
     u_sh deg;
     short *ch; // chord data :
		// -k is the end of chord k without arrow
		//  k is the end of chord k with arrow
		//
		// chords in GD must be labelled 1,...,degree


// GD(u_sh d): deg(d), ch(new short[2*d]) {}
// GD(u_sh d, short *c): deg(d), ch(copyarray(c,2*d)) {}
  GD(u_sh d, short c[]): deg(d), ch(copyarray(c,2*d)) {}
  GD(const GD & d): deg(d.deg), ch(copyarray(d.ch,2*d.deg)) {}

  GD(u_sh d,...): deg(d), ch(new short[2*d])
  { va_list argptr;

    va_start(argptr,d); // od.  argptr=...;


#define NAP if(argptr==NULL) { va_end(argptr); return; }

#define FOR(i,rg) for(u_sh i=0;i<rg;i++)  
#define IFOR(rg) FOR(i,rg)

#define INITCMP(cmp,range,type) \
    IFOR(range) { \
      NAP \
      cmp[i]=(type)(*(int *)argptr);  \
      va_arg(argptr,int);  \
    }

    INITCMP(ch,2*d,sh)

    va_end(argptr);

  }


  ~GD() { delete [] ch; }

  short & operator [] (u_sh i) const { return ch[i]; }
  
  GD & operator =(const GD & r)
  { deg=r.deg;
    delete [] ch;

    ch=copyarray(r.ch,2*deg);

    return *this;
  }

  friend ostream & operator <<(ostream & o,const GD & r)
  { o<<"GD ("<<r.deg<<",   ";

    IFOR(2*r.deg)
      o<<r[i]<<(i==2*r.deg-1?"  ":", ");

    return o<<")"<<endl;
  }
  
  bool operator == (GD r) const
  { 
     if(deg!=r.deg) return false;

     // GD r=s;
     u_sh k=2*deg;

     FOR(o,k)
     { 
        sh j=r[k-1];

        for(u_sh i=k-1;i>0;i--)
        {
           // r[i]=atst(r[i-1],(sh)abs(j));
	   r[i]=r[i-1];
        }
	// roll array of r

        // r[0]=sgn(j);
	r[0]=j;

        if (cmparray(r.ch,ch,k)) return true;
	// and compare with *this
     }

     return false;
  }

  GD choose (u_sh *d,u_sh n) const
  // choose from GD *this the n chords specified in d
  // and number each chosen chord by the pos in d (1st pos=1,
  // last=n)
  {  
     GD p(n);
     u_sh s,i,j;


     for(j=i=0;j<2*deg;j++)
       if(s=member((u_sh)abs((*this)[j]),d,n)) p[i++]=s*sgn((*this)[j]);


     return p;
  }

  bool cycl_match(u_sh p,u_sh q,u_sh r) const
  {
    u_sh t[3]={p,q,r};
    GD w=choose(t,3);
    u_sh i[3]={member(sh(1),w.ch,6),
	       member(sh(2),w.ch,6),
	       member(sh(3),w.ch,6)
	      };
    ret (i[2]-i[0])*(i[0]-i[1])*(i[1]-i[2])>0;
  }

  u_sh link_mode(u_sh p,u_sh q) const
  // link mode for chords p,q in *this
  {
     u_sh f[2]={p,q};
     GD s=this->choose(f,2);


// #define TST(a,b) if(s==GD(2,a)) return b;

     sh ff[6][4]={

		{1,2,-1,-2},     // value 0:    p & q linked, q dist.
		{1,-2,-1,2},     // value 1:    p & q linked, p dist.
		{1,-1,2,-2},     // value 2:    p & q not linked, -p -q
		{-1,1,2,-2},     // value 3:    p & q not linked, +p -q
		{1,-1,-2,2},     // value 4:    p & q not linked, -p +q
		{-1,1,-2,2}      // value 5:    p & q not linked, +p +q
	};

     for(int i=0;i<6;i++)
       if(GD(2,ff[i])==s) return i;

       // return 6;
  }

   inline u_sh conf_mode(u_sh p,u_sh q,u_sh r) const
   {  return 256*link_mode(p,q)+16*link_mode(p,r)+link_mode(q,r); }
   // a 3 digit # with all linking info

};  //end class GD



// general scheme for a weight function
// a=name
// b=return value

#define WGT_FNC(a,b) \
inline rat a(const sh wp,const sh wq,const sh wr, \
	   const sh ipp,const sh iqp,const sh irp, \
	   const sh ipm,const sh iqm,const sh irm, \
	   const sh npp,const sh nqp,const sh nrp, \
	   const sh npm,const sh nqm,const sh nrm, \
	   const sh wpp,const sh wqp,const sh wrp, \
	   const sh wpm,const sh wqm,const sh wrm, \
	   const u_sh deg) \
{ return b; }

#define WGT_FNC2(a,b) WGT_FNC(a,rat(b)/rat(deg-2))
// weight function for 2 vars
// division needed to factor out summation over the degree-2 choices
// of r


WGT_FNC(sg3w,wp*wq*wr) // w(p)*w(q)*w(r)

WGT_FNC2(sg2w,wp*wq) // w(p)*w(q)

WGT_FNC2(sg1_2w,wp+wq) // w(p)+w(q)

WGT_FNC2(sg2_i,wp*wq*(ipp+ipm-iqp-iqm))
// w(p)*w(q)*(i_p-i_q)

WGT_FNC2(sg2_d,wp*wq*(ipp-ipm+iqp-iqm))
// w(p)*w(q)*(d_p+d_q)

WGT_FNC2(sg2_n,wp*wq*(npp-npm+nqp-nqm))
// w(p)*w(q)*(n_p+n_q)

WGT_FNC2(w_p,wp)
// w(p)

class k_link;

class ELGD: public GD // extended link GD
{  

   sh *writhe;
   sh *i_plus;
   sh *i_minus;
   sh *n_plus;
   sh *n_minus;
   sh *w_plus;
   sh *w_minus;
   sh *typen;

public:
  ELGD(u_sh d,...):
       GD(d),
       writhe(new sh[d]),
       i_plus(new sh[d]),
       i_minus(new sh[d]),
       n_plus(new sh[d]),
       n_minus(new sh[d]),
       w_minus(new sh[d]),
       w_plus(new sh[d]),
       typen(new sh[d])
       {
          va_list argptr;

          va_start(argptr,d); // od.  argptr=...;

          INITCMP(ch,2*d,sh)
          INITCMP(writhe,d,sh)
          INITCMP(i_plus,d,sh)
          INITCMP(i_minus,d,sh)
          INITCMP(n_plus,d,sh)
          INITCMP(n_minus,d,sh)
          INITCMP(w_plus,d,sh)
          INITCMP(w_minus,d,sh)
          INITCMP(typen,d,sh)


          va_end(argptr);

       }

     ELGD(u_sh l,sh d[],sh w[],sh ip[],sh im[],
	  sh np[],sh nm[],sh wp[],sh wm[],sh ty[]):
       GD(l,d),
       writhe(copyarray(w,l)),
       i_plus(copyarray(ip,l)),
       i_minus(copyarray(im,l)),
       n_plus(copyarray(np,l)),
       n_minus(copyarray(nm,l)),
       w_plus(copyarray(wp,l)),
       w_minus(copyarray(wm,l)),
       typen(copyarray(ty,l)) {}

     ELGD(GD i): GD(i),
       writhe(new sh[i.deg]),
       i_plus(new sh[i.deg]),
       i_minus(new sh[i.deg]),
       n_plus(new sh[i.deg]),
       n_minus(new sh[i.deg]),
       w_plus(new sh[i.deg]),
       w_minus(new sh[i.deg]),
       typen(new sh[i.deg])
       {}

     ~ELGD() { delete [] writhe,i_plus,i_minus,n_plus,n_minus,w_plus,w_minus,typen; }

   

  ELGD(const ELGD & r): GD((GD)r),
    writhe(copyarray(r.writhe,deg)),
    i_plus(copyarray(r.i_plus,deg)),
    i_minus(copyarray(r.i_minus,deg)),
    n_plus(copyarray(r.n_plus,deg)),
    n_minus(copyarray(r.n_minus,deg)),
    w_plus(copyarray(r.w_plus,deg)),
    w_minus(copyarray(r.w_minus,deg)),
    typen(copyarray(r.typen,deg))
  { 
  }


  ELGD & operator =(const ELGD & r)
  { (GD)*this=(GD)r;
  
    delete [] writhe,i_plus,i_minus,n_plus,n_minus,w_plus,w_minus,typen;
 
    writhe=copyarray(r.writhe,deg);
    i_plus=copyarray(r.i_plus,deg);
    i_minus=copyarray(r.i_minus,deg);
    n_plus=copyarray(r.n_plus,deg);
    n_minus=copyarray(r.n_minus,deg);
    w_plus=copyarray(r.w_plus,deg);
    w_minus=copyarray(r.w_minus,deg);
    typen=copyarray(r.typen,deg);

    return *this;
  }



  inline sh wr(u_sh p) const { return writhe[p-1]; }
  inline sh ip(u_sh p) const { return i_plus[p-1]; }
  inline sh im(u_sh p) const { return i_minus[p-1]; }
  inline sh np(u_sh p) const { return n_plus[p-1]; }
  inline sh nm(u_sh p) const { return n_minus[p-1]; }
  inline sh wp(u_sh p) const { return w_plus[p-1]; }
  inline sh wm(u_sh p) const { return w_minus[p-1]; }
  inline sh typ(u_sh p) const { return typen[p-1]; }

  inline u_sh type_mode (u_sh p,u_sh q,u_sh r,u_sh m) const
  { return 256*MOD(typ(p),m)+16*MOD(typ(q),m)+MOD(typ(r),m); }
 
  // friend k_link::operator ELGD();
  friend k_link;

  friend ostream & operator <<(ostream & o,const ELGD & r)
  {

    o << "ELGD(" <<endl;

    o << (GD)(r);

#define OUT(a) o << #a "="; outputarray(o,r.a,r.deg);

    OUT(writhe)
    OUT(i_plus)
    OUT(i_minus)
    OUT(n_plus)
    OUT(n_minus)
    OUT(typen)

   
    return o<<")"; 

  }
}; //end class ELGD


// the signature of a weight function
typedef rat (*w_fct)
(const sh wp,const sh wq,const sh wr,		// w
 const sh ipp,const sh iqp,const sh irp,		// i+
 const sh ipm,const sh iqm,const sh irm, 		// i-
 const sh npp,const sh nqp,const sh nrp, 		// n+
 const sh npm,const sh nqm,const sh nrm, 		// n-
 const sh wpp,const sh wqp,const sh wrp, 		// w+
 const sh wpm,const sh wqm,const sh wrm, 		// w-
 const u_sh deg);			// # crsgs

struct summand { // one term in a Gauss sum
    u_sh types;
    u_sh conf;
    rat cf;
    w_fct proc;
    summand(u_sh t,u_sh cn,rat c,w_fct pr):
    types(t), conf(cn), cf(c), proc(pr) {}
    summand(): types(0), conf(0), cf(0), proc( (w_fct)0 ) {}
    bool operator == (const summand & s)
    { return types==s.types &&
	     conf==s.conf &&
	     cf==s.cf &&
	     proc==s.proc ; 
    }
};


// sum over p,q,r of conf. type matching to pattern
// `conf' with type mode `types' the value of `proc(w,i+,i-,deg)'
// with coefficient `cf'



static inline bool cnf__mt(u_sh u,u_sh c)
    {
      switch(c)
      { case 9: return u<3;
	CASE 8: return true;
	CASE 7: return u>1;
	CASE 6: return u<2;
	DEFL  : return u==c; 
      }
    }


// match between two 3-digit-numbers:
// conf mode `u' and conf pattern `c'
// match digitwise:
// 0,...,5 matches itself
// 6	   matches [01] (linked or any Z2-type)
// 7       matches [2345] (not linked)
// 8       matches everything [0-5]
// 9       matches [012] (any Z3-type)

// IMP. NOTE: leading 0s need NOT 2 B omitted in u&c !!!

static bool conf_match(u_sh u,u_sh c)
    {
      do
      { 
	if(!cnf__mt(u%16,c%16)) return false;
      }
      while (u/=16,(c/=16)||u);

      return true;
    }

    bool Ztype_match(sh p,sh q,sh r,u_sh t,int h)
    {
      sh x[3]={p,q,r},
	 y[3]={t & 0x100, t& 0x10, t & 1};

	 IFOR(3)
	 {
	   if(y[i]==0 && x[i]!=0 ||
	      y[i]==1 && x[i]!=h ||
	      y[i]==2 && x[i]!=-h)
	      ret false;
	 }
	 ret true;
    }

class GInv { // Gauss sum invariant

    string name;
    summand *sum;

public:

    u_int len;

    GInv(string s="",u_sh d=0,...): name(s), len(d), sum(new summand[d]) {

      va_list argptr;

      va_start(argptr,d);
    
      IFOR(d)  {

      NAP
      sum[i].types=(u_sh) va_arg(argptr,int);  

      NAP
      sum[i].conf=(u_sh) va_arg(argptr,int);  

      NAP
      sum[i].cf=rat( va_arg(argptr,char *)  );  

      NAP
      sum[i].proc= va_arg(argptr,w_fct);  

      }

      va_end(argptr);
    }

    GInv (const GInv & s ):
      name(s.name), sum(copyarray(s.sum,len=s.len)) {}

    GInv operator = (GInv s) {
      name=s.name;
      delete [] sum;
      sum=copyarray(s.sum,len=s.len);
      return s;
    }

    ~GInv() { delete [] sum; }


public:

    friend string nme(GInv s) { return string(s.name); }

    friend ostream & operator <<(ostream & o,GInv s)
    {
    
      o<<"GInv ("<<endl;
      IFOR(s.len) 
      { o<<form("%3d, %3d, ",s.sum[i].types, s.sum[i].conf);
        // o<<(s.sum)[i].types<<" "<<(s.sum)[i].conf;
        o<<" "<<
	  (s.sum)[i].cf<<","<<
	  (void *) (s.sum)[i].proc<<","<<endl;
      }
      return o<<")"<<endl;
    
    } 


    summand & operator [](u_sh j) const { return sum[j]; }


    rat operator () (ELGD b,u_sh m=2, int h=1) const // what is the invariant
				   // applied on a ELGD
    { 
      rat s=0;
      u_sh  p,q,r,t,u;

      // ELGD wi=b;

      if(b.deg<3) return 0;

      for(p=1;p<=b.deg;p++) // chords in GD must 
      for(q=1;q<=b.deg;q++) // be labelled 1,...,degree
      for(r=1;r<=b.deg;r++)
	if(p!=q&&p!=r&&q!=r) //choose chords p,q,r distinct
	{ 
	   // cerr<<(p)<<(q)<<(r)<<endl;

	   t=b.type_mode(p,q,r,m);


	   u=b.conf_mode(p,q,r);



	   IFOR(len) // for all terms in the inv.
           {

	     if(
		    (m<2?Ztype_match(b.typ(p),b.typ(q),b.typ(r),t,h) :
		      conf_match(t,(*this)[i].types)) &&
		    conf_match(u,(*this)[i].conf) &&
		    (*this)[i].cf != rat(0)
	       )
		// check if p,q,r have the right types
		// and their conf matches pattern of the summand
		 {     

		      //  cerr<<b.wr(p)<<b.wr(q)<<b.wr(r)<<b.deg;

		 rat k=
		   ((*this)[i].proc)(
		       b.wr(p),b.wr(q),b.wr(r),
		       b.ip(p),b.ip(q),b.ip(r),
		       b.im(p),b.im(q),b.im(r),
		       b.np(p),b.np(q),b.np(r),
		       b.nm(p),b.nm(q),b.nm(r),
		       b.wp(p),b.wp(q),b.wp(r),
		       b.wm(p),b.wm(q),b.wm(r),
		       b.deg
		       );

		       rat l=(*this)[i].cf;
		       // cerr<<endl;

		       s+=k*l;


		     }
            }

        }


	return s;

    }

}; // end class GInv




#define INIT_INV(a,b) GInv a(#a,b,
// begin of invt initialization
// a=name, b=# summands
#define END_INV );
// end of invt initialization

#define term(a,b,c,d) 0x ## a,0x ## b,#c,d

         
INIT_INV(vt33,14)
        
  term(111,101,-1/3,sg3w),
  term(100,101,-1,sg3w),
  term(100,510,-1,sg3w),
  term(101,510,-1,sg3w),
  term( 10,210, 1,sg3w),
  term( 11,210, 1,sg3w),
  term(110,531, 1,sg3w),
  term(101,241, 1,sg3w),
  term(110,241, 1,sg3w),
  term(101,531, 1,sg3w),
  term(111,531, 1,sg3w),
  term(100,531, 1,sg3w),
  term(111,241, 1,sg3w),
  term(100,241, 1,sg3w)
	
END_INV

INIT_INV(vassiliev3,12)        // Polyak-Viro Vassiliev 3?
   term(  0,101,   1/3,sg3w),  // obtained by summing over all
   term(  1,101,     1,sg3w),  // possible types of crossings
   term( 11,101,     1,sg3w),  // for the configurations, in an
   term(111,101,   1/3,sg3w),  // attempt to account for all
   term(  0,210,   1/2,sg3w),  // occurrences , regardless of type
   term(  1,210,   1/2,sg3w),
   term( 10,210,   1/2,sg3w),
   term( 11,210,   1/2,sg3w),
   term(100,210,   1/2,sg3w),
   term(101,210,   1/2,sg3w),
   term(110,210,   1/2,sg3w),
   term(111,210,   1/2,sg3w)
END_INV

INIT_INV(vt34,31)

  term(100,101,-2,sg3w),
  term( 11,101,-2,sg3w),
  term(110,531, 2,sg3w),
  term(101,351,-2,sg3w),
  term(101,241, 2,sg3w),
  term(110,421,-2,sg3w),
  term(  1,531,-2,sg3w),
  term( 10,351, 2,sg3w),
  term(  1,421, 2,sg3w),
  term( 10,241,-2,sg3w),
  term(111,531, 2,sg3w),
  term(  0,241,-2,sg3w),
  term(  0,421, 2,sg3w),

  term(111,351,-2,sg3w),
  term(111,421,-2,sg3w),
  term(  0,351, 2,sg3w),
  term(  0,531,-2,sg3w),
  term(111,241, 2,sg3w),
  term(110,551, 2,sg3w),
  term(  1,221, 2,sg3w),
  term(110,441,-2,sg3w),
  term(  1,331,-2,sg3w),
  term( 10,551, 2,sg3w),
  term(101,221, 2,sg3w),
  term( 10,441,-2,sg3w),
  term(101,331,-2,sg3w),

  term( 16,188,-1,sg1_2w),
  term(100,  0, 2,sg3w),
  term(110,  0, 2,sg3w),
  term( 16,188, 2,sg2_d),
  term( 16,188,-1,sg2_n)

END_INV


INIT_INV(vt35,14)
        
  term(  0,101,-1/3,sg3w),
  term( 11,101,-1,sg3w),
  term(100,510, 1,sg3w),
  term( 11,210,-1,sg3w),
  term(101,510, 1,sg3w),
  term( 10,210,-1,sg3w),
  term( 10,421, 1,sg3w),
  term(  1,421, 1,sg3w),
  term(  1,351, 1,sg3w),
  term( 10,351, 1,sg3w),
  term(  0,421, 1,sg3w),
  term( 11,421, 1,sg3w),
  term(  0,351, 1,sg3w),
  term( 11,351, 1,sg3w)
	
END_INV

INIT_INV(vt3,4)

   term(666,000,     1,sg3w),   // (3,3)
   term(666,101,   1/3,sg3w),   // (3,3)
   term(666,366,     1,sg3w),   // (4,2)0
   term(666,688, 1/4,sg1_2w)    // p,q linked; r doesn't matter
   // term(  1,688, 1/4,sg1_2w)  // p,q linked; r typ 1 doesn't matter
   // term(  0,688, 1/4,sg1_2w), // p,q linked; r typ 0 doesn't matter

END_INV

INIT_INV(vt32, 15)

    // vt3 over crsgs of type 0 ...
    term(  0,000,     1,sg3w),   // (3,3)
    term(  0,101,   1/3,sg3w),   // (3,3) vvv (symm. group Z_3!)
    term(  0,366,     1,sg3w),   // (4,2)0
    term(  6,688, 1/4,sg1_2w),   // p,q linked; r doesn't matter
				 // (symm. group Z_2)

    // ... and the rest
    term(100,101,     4,sg3w),
    term(100,566,     1,sg3w),
    term(101,566,     1,sg3w),
    term(100,266,     1,sg3w),
    term(101,266,     1,sg3w),
    term(110,566,  -1/2,sg3w),
    term(111,566,  -1/2,sg3w),
    term(110,266,  -1/2,sg3w),
    term(111,266,  -1/2,sg3w),
    term(  1,566,   1/2,sg3w),
    term(  1,266,   1/2,sg3w) 
   
END_INV

INIT_INV(vt31,11)
         
  term(  6,188,    -1,sg2_i),
  term( 11,300,     1,sg3w),
  term( 11,311,    -1,sg3w),
  term(100,510,     1,sg3w),
  term(100,501,    -1,sg3w),
  term(100,000,    -1,sg3w),
  term(  1,311,    -1,sg3w),
  term(106, 88,  -1/2,w_p),
  term(  1,000,     1,sg3w),
  term(  1,300,     1,sg3w),
  term(106,188,   1/2,w_p) 
         
END_INV

GInv vt0("0",0);

// a dummy to fill unused entries



// ----------------------------------------



// part of knot.C


int crossing(comp x1,comp x2,comp y1,comp y2,double & z)
// if line FROM y1 TO y2 doesn't cross or touch line THROUGH x1 and x2
// return 0.
// if it crosses return 2 if y2 is in upper halfplane
// and -2 if y2 is in lower halfplane.
// if both y1 and y2 are on the line through x1 and x2, return 
// 4 if x1 not betw y1 & y2, else -4.
// if ex. one of both y1 and y2 are on the line thourgh x1 and x2
// (i.e. line from y1 to y2 touches line through x1 and x2) return
// 1 if line is from below to 0 or from 0 to above and else
// -1.
// in case there is intersection or touch set z so that
// z*(x2-x1)+x1 is the intersection/touch point.

// ASSUMPTION: x1,x2,y1,y2 are all distinct

{
   if(x1==x2 || y1==y2) ret -10; 

   comp z1=(y1-x1)/(x2-x1),
	z2=(y2-x1)/(x2-x1);

	if(sgn(Im(z1))==0 && sgn(Im(z2))==0) return 
	  1==sgn(Re(z1))*sgn(Re(z2)) ? 4 : -4;

	if(sgn(Im(z1))==sgn(Im(z2))) return 0;


	z=(abs(Im(z1))*Re(z2)+abs(Im(z2))*Re(z1))/
	  (abs(Im(z1))+abs(Im(z2)));

        return sgn(Im(z2))-sgn(Im(z1));

}


class ngon { // a plain pl-curve
  u_sh len; // #vertices
  comp *pts; // vertices

  public:
    friend u_sh lg(ngon k) { return k.len; }
    ngon(u_sh l,comp *p): len(l),pts(copyarray(p,l)) {}
    ngon(u_sh l): len(l), pts(new comp[l]) {}
    ngon(const ngon & s): pts(copyarray(s.pts,len=s.len)) {}
    ~ngon() { delete [] pts; }

    ngon & operator =(const ngon & s) { delete [] pts;
      pts=copyarray(s.pts,len=s.len); return *this; }

    comp & operator [] (u_sh k) { return pts[k%len]; } 
    // the kth vertex
    friend ostream & operator <<(ostream & o,ngon s)
    { o<<endl;
      for(u_sh i=0;i<s.len;i++)
      { // o<<i<<endl; 
	// o<<(s.pts)[i-1]<<","; 
	o<<s[i]<<","<<endl;
	}

	return o<<endl;
    }

};


sh windingnr (comp pt, ngon k)
// winding of ngon k around pt
{  comp dir=k[1];
   double z;
   rat w=0;
   int a;

   // choose shaft from `pt' through `dir'
   // and count with signs how many times `k' inters that shaft.
   // if one of the pts in `k' is on the shaft, only 1/2
   // of the sign is taken

   for(u_sh i=0;i<lg(k);i++)
   {
     switch(a=crossing(pt,dir,k[i],k[i+1],z))
     {

       case -4 : cerr<<form("center pt lies on line %d\n",i); break;
		  // should however NEVER occur in SnapPea files
       case 4: // move along the shaft (or its opposite)
	       // doesn't change anything
       case 0: break; // no crsg of line
       default : if (z>0) w+=rat(a,2);
		// if crsg of shaft, then z>0

     }
   }

   return int(w);

}

int whitind(ngon x) {
// the Whitney index of a pl-curve
  // static int j=0;

  // if(TRC_FLAG && j++) cerr<<"!!!!!!\n";

  double u=0;
  // int i=0;

  for(u_sh y=1;y<=lg(x);y++)
    { 
      // if(y==1 && i==1 || ++k>1000) break;
      comp c=(x[y+1]-x[y])/(x[y]-x[y-1]);
      u+=atantopi(Im(c),Re(c))/2;
      // i=1;
    }

    return nrint(u);

}



class knotpt: public comp { // a point in a pl-knot diagram
// every knot pt is a comp # ...

  public:
  int cross; // ... with some crossing info
  // operator comp() { return comp(real,imag); }

   // crossing info in each knotpt :
   // 0 - vertex of plain curve;
   // -n - undercrossing ; n = # of other line + 1 (1st line is line 0)
   // n - overcrossing ; n = # of other line + 1 (1st line is line 0)


    knotpt (comp s=0,int c=0): comp(s), cross(c) {}
    friend ostream & operator <<(ostream & o,knotpt k)
    { return o<<"knotpt("<<comp(k)<<","<<k.cross<<")"<<endl; }


// bool oper == 
// MAY CAUSE PROBLEMS WHEN WEAK COMPARISON OF COMP IS NEEDED
// FOR TWO KNOTPTS

  bool oper == (const knotpt & b) const
    { ret (comp)(*this)==(comp)b && cross==b.cross; }


};

class crsg { // a crsg is repres by # of line of
	     // over- and undercrossing
public:
  u_sh above,
       below;

       crsg(u_sh a=0,u_sh b=0): above(a), below(b) {}
       crsg operator !() { return crsg(below,above); }
       bool operator == (crsg s) { return above==s.above &&
					  below==s.below ; }
       friend ostream & operator <<(ostream & o, crsg c) {
	 return o<<"crsg("<<c.above<<","<<c.below<<")"<<endl;
       }

};


class knot;


class PSpt: public comp {
  public:
  PSpt(comp k=0): comp(k) {}
  friend ostream & operator << (ostream & o, const PSpt& p)
  { return o<<" "<<Re(p)<<" "<<Im(p)<<" "; }
  friend istream & operator >> (istream & i, PSpt& p)
  { return i>>SetRe(p)>>SetIm(p); }
};


void bbox(const knot& k, PSpt & xa, PSpt & xb);

inline comp normalize (const comp& z,double n=1) { return (z/norm(z))*comp(n); }
//#define normalize(z,a) ((z)/norm(z))*(a)


double PS_wgt=1; // wight for sharpness/smoothness of
// vertices in PS image, should be in (1/2,1]

u_int PS_crs=100; // dafult dist of crsg line interruption
// = len of diagonal/cos(angle)/PS_crs

u_int PS_ar=30; // dafult len of arrow = len of diagonal/PS_ar

int arrow_flag=1; // 1- draw arrow on 1st segment of open
		    // tangle component; 0 - do not ....

string inv_str=(char *)0; // string to specify which inv #s
// have 2 B comp., default is NULL - all invs


double PS_aw=0.2;

class knot { // a knot diagram 
protected:
public:

  u_sh len; // # of vertices of plane curve
  u_sh ncr; // # crossings of plane curve

  knotpt *kpts; // coords of vertices & crossings of plane curve
  comp *vrt;    // vertex coords
  crsg *crss;   // crossings ordered by order of first passing
  comp *ccrd;   // crsg coords of crsgs in `crss'

  public:

    friend void bbox(const knot&, PSpt &,PSpt &);

    friend ostream & operator <<(ostream & o, const knot & k) {
   
      o<<"knot("<<endl;

      for(sh m=0;m<2*k.ncr+k.len;m++)
      { o<<m<<".kpts="<<k.kpts[m]; // <<endl;
      }
      o<<endl;
    
      for(sh m=0;m<k.len;m++)
      { o<<m<<".vrt="<<k.vrt[m]<<endl;
      }
   
   
      for(sh m=0;m<k.ncr;m++)
      { o<<m<<".crss="<<k.crss[m]; // <<endl;
      }
      o<<endl;
   

      for(sh m=0;m<k.ncr;m++)
      { o<<m<<".ccrd="<<k.ccrd[m]<<endl; }
      
      return o<<")"<<endl;
   
    }

    operator GD() const;

    knot():len(0), ncr(0), vrt(0), kpts(0), crss(0), ccrd(0) {}
    // a dummy constr. needed to be later able to call
    // `k_link k;'


    knotpt & operator [] (u_sh k) { return kpts[MOD(k,(len+2*ncr))]; }
    knot (u_sh l,comp *pts,u_sh cl,crsg *crs);
    knot (u_sh l,comp *pts,u_sh cl,char *crstr);
    knot(ifstream & i,int=0);
    ~knot() { delete [] kpts,vrt,crss,ccrd; }
    knot & operator =(const knot & s)
    { len=s.len; ncr=s.ncr; 
      delete [] kpts,vrt,crss,ccrd;
      kpts=copyarray(s.kpts,len+2*ncr); 
      crss=copyarray(s.crss,ncr);
      ccrd=copyarray(s.ccrd,ncr);
      vrt=copyarray(s.vrt,len);

      return *this; 
    }


    knot (const knot & s)  {
      // delete [] kpts,vrt,crss,ccrd;
      len=s.len;
      ncr=s.ncr;
      kpts=copyarray(s.kpts,len+2*ncr);
      crss=copyarray(s.crss,ncr);
      ccrd=copyarray(s.ccrd,ncr);
      vrt=copyarray(s.vrt,len);
    }

 protected:

    double help_writhe(crsg c) const
    { u_sh c_a=c.above, // above & below lines in crsg
	   c_b=c.below; 

      comp l_a = vrt[(c_a+1)%len] - vrt[c_a] ,
	   l_b = vrt[(c_b+1)%len] - vrt[c_b] ;
	   // the vectors of both lines as comp #s
	   // `%len' in case crsg on last line

      return Im(normalize(l_b)/normalize(l_a));
    }

 private:

   inline void do_next_vert(u_sh & y, char *str,sh b,ostream & o=cout)

   {

      // needed 4 PS() proc

      u_sh tlen=len+2*ncr,
	   y1=(y+1)%tlen;
      PSpt x1,x2;
      sh a=kpts[y1].cross;

      comp dl;
      
      switch(sgn(a))
      {
      // in case next knotpt is a crsg draw it and set `y'
      // to the knotpt after the crsg
	case 1: // overcr
	  o<<PSpt(kpts[y1])<<str; y=(y+2)%tlen;

        CASE -1: // undercr

          bbox(*this,x1,x2);

          dl=normalize(kpts[y1]-kpts[y],(norm(x2-x1)/PS_crs)*
	    min(3.5,
		1/abs(help_writhe(crsg(abs(a)-1,b)))
	       )
	    );

	  o<<PSpt(kpts[y1]-dl)<<str<<PSpt(2*dl)<<"rm";
	  y=(y+2)%tlen;

	  // in case 1 & -1 we can simply write `y+1' inst. of `y1'
	  // since kpts[0] is always a vertex, so y+1 never == tlen, ...

        CASE 0: // vertex
	  o<<PSpt((kpts[y1]+kpts[y])/2)<<str; y=y1;
	  // ... here of course not ! once y+1 is == tlen
      }

   } // do_next_vert

 public:

   void PS(ostream & o=cout) { 
   // write PostScript for drawing the knot
   // smooth vertices using curves from the crossing points
   // to the middlepoints of lines containing no crossing

   // the output of the last coord pair of each drawing operation
   // & the stepping of `y' is done by `do_next_vert'
 
     PSpt xa,xb;
     bbox(*this,xa,xb);
     o<<"%%BoundingBox:"<<xa<<xb<<endl;

     u_sh y=0,y0;
     o<<"MyPiCDict begin gs np "<<norm(xb-xa)/300<<" sw";
     // width of line is 1/300 of the length of the diagonal
     // of the bounding box

     do_next_vert(y,"m pt",0,o);

     y0=y; // pos. to break up the loop, always 1 (if kpts[1] is a vertex)
     // or 2 (if it is a crsg)
     // o<<y;
     comp c=normalize(comp(kpts[y0])-comp(kpts[0]),norm(xb-xa)/PS_ar);

     // `y' indicates the next control pt
     // either the PS pen is in the middle of a line without crsg
     // and `y' points to its endpoint or
     // the pen is on a crsg and `y' points to next knotpt
     
     


     
     // c=c/norm(kpts[y0]-kpts[0]);
     // c=c*norm(xb-xa)/30;
    
     o<<" "<<2-2*PS_wgt;


      					   // direction to draw
					   // orient. arrow
     sh b=0; // counts the current line

     // from now on, `kpts[y]' always gives the direction in which
     // the next drawing op. should be done

     loop {
           o<<endl;


	  if(kpts[y].cross)
	    { --y; do_next_vert(y,"l",b,o); }
	    // note that `kpts[0]' is a vertex, so y is never 0 here!
	    else
            {
	      b=(b+1)%len;
	      o<<PSpt(kpts[y]);
		 // PSpt(kpts[y]*PS_wgt+(*this)[y-1]*(1-PS_wgt))<<
		 // PSpt(kpts[y]*PS_wgt+(*this)[y+1]*(1-PS_wgt));
	      do_next_vert(y,"@C",b,o);
	      if(y==y0) goto marke;
	    }//if /else


	   }//loop

     marke: // draw arrow
	    o<<" p m pt"<<
		  PSpt(comp(-1,PS_aw)*c)<<
		  "rl m pt"<<
		  PSpt(comp(-1,-PS_aw)*c)<<
		  "rl m s gr e"<<endl; // and stroke

    }//PS()


    knot operator -() const { // how to invert the orient of a knot

      GD gd(*this); // constr the GD

      crsg ncrg[ncr];
      // put the crss from `crss' into `ncrg' in the order
      // of 2nd passing (i.e., 1st passing in the reversed version).
      // with line `k' changed to `len-1-k'
      // go from the end of `gd.ch' and delete both occurences of a crsg
      // while passing it the 1st time, then skip deleted entries

      u_sh pv; sh z,x;
      // z - sec. occurence of a crsg in `gd'
      // x - first one
      // pv - filling level of `ncrg' = # so far crsgs passed from
      //      the end of `gd.ch'


      for(pv=0,z=2*ncr-1;z>=0;z--)
      {
	if(gd[z]) { crsg l=crss[abs(gd[z])-1];
	
	  ncrg[pv++]=crsg(len-1-l.above,len-1-l.below);

	  for(x=z-1;x>=0;x--) // first oc. is x
	  { if(gd[z]== -gd[x] )
	      { 
		
		gd[x]=gd[z]=0; break; } // delete both oc.
	  } // for x

	  if(x<0) cerr<<"wrong `ch' array\n"; // hope it never occurs

        } // if
      } // for z

      comp r[len];
      
      r[0]=vrt[0];
      for(u_sh y=1;y<len;y++)
        r[y]=vrt[len-y];
       				 // needed to release memory
				// alloc by `reverse()'

      return knot(len,r,ncr,ncrg);

      // delete [] r;

      // return s;

   } // operator -()


   knot mirr(double axis=0) const { // how to mirror a knot --
			// conjugate all coords of vertices
			// this is NOT the stand. mirroring:
			// change all crsgs;

   // mirror with resp. to axis Im(.) == axis

 
     comp nvrt[len]; // new vertices 

     for(u_sh y=0;y<len;y++) nvrt[y]=!vrt[y]+comp(0,2*axis);

     return knot(len,nvrt,ncr,crss);
   }

   knot flip(double axis=0) const;

   knot operator !() const { // mirror a knot
     PSpt xa,xb;
     bbox(*this,xa,xb);
     return mirr((Im(xa)+Im(xb))/2);
   }


}; // end class knot

knot knot::flip(double axis=0) const { // how to filp a knot --
				// conjugate all coords of vertices
				// and change all crsgs
   // flip with resp. to axis Im(.) == axis

 
     crsg ncrs[ncr]; // new crossings 

     for(u_sh y=0;y<ncr;y++) ncrs[y]=!crss[y];

     return knot(len,vrt,ncr,ncrs).mirr(axis);

   } // flip

knot::operator GD() const { // make a Gauss diag


    GD gd(ncr);

    //fill array `ch' of `gd' 

    for(u_sh y=0,p=0,cc=0,b=0 ; y<len+2*ncr ; y++)
    // b - current line #
    // y - current index in `kpts'
    // p - filling level of `ch'
    // cc - # of currently passed chords (i.e. # which, aug. by 1,
    //      will be assigned to the next new crsg passed )
    {

       sh a,q;
       // q - type of current knotpt
       // a - other line in a crsg

       q=sgn(a=kpts[y].cross);
       // if (y==0) TRC(*this);


       // 0 - vertex
       // 1 - overcr.
       // -1 - undercr.

       if(q==0)
       { y>0 && b++; continue; } // skip vertices, going to next line

       a=abs(a)-1;

       // b -this line #, a - other line #

       if(a<b) { // curr. line b higher than other line a -
		 // crsg passed the 2nd time
        u_sh z;
	crsg w= q<0 ? crsg (a,b) : crsg(b,a);
        // crsg to look for in `crss'
	// if q<0 a above, b below
	// if q>0 b above, a below
        for(z=0;z<cc;z++) // look for 1st occurence
	{
	   if(crss[z]==w) // curr. crsg found as #(z+1)
			  // note that crsg 1 in the GD appears
			  // at pos 0 in `crss' and `ccrd'

	   { gd[p++]=q*(z+1);  break; }
        }

	ERROR(z==cc && cc>0,"no correct order of crsgs\n");

       }
       else // a>b
       {

	  // curr. line b lower than other line a -
	  // crsg passed the 1st time

          gd[p++]= q * ++cc; // use nect # for `ch'
			     // chs. in a GD R #ed from 1, so RPEincrem.
       } 
    }// for y

    return gd;
 }

void bbox(const knot& k, PSpt & xa, PSpt & xb)
{

  xa=xb=k.vrt[0];



  for(u_sh l=1;l<k.len;l++)
  {
// 	TRC(Re(k.vrt[l]));

    if(Re(k.vrt[l])<Re(xa)) SetRe(xa)=Re(k.vrt[l]);
    if(Re(k.vrt[l])>Re(xb)) SetRe(xb)=Re(k.vrt[l]);
    if(Im(k.vrt[l])<Im(xa)) SetIm(xa)=Im(k.vrt[l]);
    if(Im(k.vrt[l])>Im(xb)) SetIm(xb)=Im(k.vrt[l]);
  }



}


class k_link: public knot { // K and T

public: comp T;
// coords of triv. link

   k_link(const k_link & s):
     knot(s), T(s.T) {
     
     }
   
   k_link & operator =(const k_link & s) {
     // *this=(knot)s;
      len=s.len; ncr=s.ncr; 
      delete [] kpts,vrt,crss,ccrd;
      kpts=copyarray(s.kpts,len+2*ncr); 
      crss=copyarray(s.crss,ncr);
      ccrd=copyarray(s.ccrd,ncr);
      vrt=copyarray(s.vrt,len);

     T=s.T;
     return *this;
   }

 friend ostream & operator <<(ostream & o, const k_link & k)   
 { return o<<(knot)k<<"T="<<k.T<<endl; }

   // operator knot() { return knot(len,vrt,ncr,crss); }

   operator ELGD() const; // end operator ELGD()

   k_link() {} // call knot() & set T=0

   k_link(ifstream & i,int fmt_mode=0);


   k_link(knot k,comp t):knot(k), T(t) {}
   sh lk() const { // lk(K,T)
     return (windingnr(T,ngon(len,vrt))); } 

   k_link(ifstream & i,comp t,int fmt_mode=0):knot(i,fmt_mode), T(!t) {}
   // we cange the compl. component for uniformity
   // with the file data

   // the inverse link
   k_link operator -() const { return k_link(-(knot(*this)),T); }
   // ATTENTION: We do NOT change orient. of T!


   // finally the flip & mirror
   k_link flip(double axis=0) const 
   {
	k_link r(((knot)(*this)).flip(axis), !T+comp(0,2*axis));
	return r;

   } // flip
 
   k_link mirr(double axis=0)const 
   {
      
      k_link r(((knot)(*this)).mirr(axis), !T+comp(0,2*axis)); 
      return r;
   } // flip
 
   k_link operator !() const  { // mirror a k_link
     PSpt xa,xb;
     bbox(knot(*this),xa,xb);
     k_link r=mirr((Im(xa)+Im(xb))/2);
     return r;
   }

   void PS(ostream & o=cout) {
     knot u=knot(*this);


     u.PS(o);
     PSpt xa,xb;
     bbox(knot(*this),xa,xb);
     o<<"MyPiCDict begin gs"<<
       PSpt(T)<<"t "<<norm(xa-xb)/120<<
       " d 0 m 0 0 3 2 r 0 360 A 0 sg fl gr e"<<endl;
   }


}; //end class k_link

sh t_writhe(ELGD k) { 
  sh s=0;
  for(u_sh y=0;y<k.deg;y++)
  {  s+=k.wr(y+1);
     // cerr<<k.wr(y+1)<<" ";
  }
  return s;
}

inline sh t_whitind(knot k) {

  int a=whitind(ngon(k.len,k.vrt));
  return a; // whitind(ngon(k.len,k.vrt));
}


k_link::operator ELGD() const

{ // how to make a ELGD out of a knot with T

   // ELGD gd(ncr); // alloc memory



   ELGD gd = GD(knot(*this));




   // so far we have `gd.ch' filled
   // now come `w,ip,im,typ' simultaneously for each crsg

   for(u_sh y=0;y<ncr;y++)
   // do all for crsg y+1

   {

      // first the writhe
      // with the preparations this is simple :

      u_sh c_above=crss[y].above, // above & below lines in crsg
	   c_below=crss[y].below; // marked by y+1
// 
//       comp l_a = vrt[(c_above+1)%len] - vrt[c_above] ,
// 	   l_b = vrt[(c_below+1)%len] - vrt[c_below] ;
// 	   // the vectors of both lines as comp #s
// 	   // `%len' in case crsg on last line

      gd.writhe[y] = sgn(help_writhe(crss[y]));

      // now i_plus & i_minus

      u_sh a=min(c_above,c_below),
	   b=max(c_above,c_below);

	   ngon D1(b-a),D2(len-b+a); // pl-curves of D+(y) & D-(y)

	   u_sh z;


	   // for(u_sh i=0;i<len;i++) TRC(vrt[i]);

	   for(z=0;z<b-a;z++) 
	   { 
	     D1[z]=vrt[z+a+1]; }
	   for(z=0;z<len-b+a;z++) D2[z]=vrt[(z+b+1)%len];


	   if(c_above>c_below) 
	   { 
	     // ngon R=D1; D1=D2; D2=R; 
	     swap(D1,D2); 
	   }
	   // now D1=D+(y) & D2=D-(y)

	   gd.i_plus[y] = windingnr(ccrd[y],D1);
	   gd.i_minus[y] = windingnr(ccrd[y],D2);

	   // it remains the type & whitney ind.


           ngon DT(lg(D1)+1);   // create a copy of D1 with curr
	   ngon DT2(lg(D2)+1);	// crsg inserted as vertex:
				// if T is very near to the crsg,
				// it may land on another side in
				// D+(y) if we just take the line
				// betw. the 2 neighbored vertices
				// without inserting crsg y as vertex

	   DT2[0]=DT[0]=ccrd[y];
	   for(z=0;z<lg(D1);z++) DT[z+1]=D1[z];
	   for(z=0;z<lg(D2);z++) DT2[z+1]=D2[z];
	   
// #define EXT(D) if (lg(D)==2) { comp i[3]={D[0],D[1],ccrd[y]}; D=ngon(3,i); }

// the 2 angles == pi in an ngon of len=2 will always
// be counted in positive sense, so such ngon will always
// have n=1. note, however, that for such ngon i+/i-
// are comp. correctly to 0

	   // EXT(D1)
	   // EXT(D2)

	   gd.n_plus[y] = whitind(DT);
	   gd.n_minus[y] = whitind(DT2);

	   ERROR(y>0 && gd.n_plus[y]+gd.n_minus[y]!=
			gd.n_plus[y-1]+gd.n_minus[y-1], "#6: "<<y)

	   gd.typen[y]= windingnr(T,DT);
	   
     }// for y

     // the writhes of D_p+,D_p-
     for(u_sh y=0;y<ncr;y++)
     {
       sh wrt1=0,wrt2=0;
       for(u_sh z=0;z<ncr;z++)
       { 
	 switch((GD(knot(*this))).link_mode(y+1,z+1))
	 {
	   case 3:
	   case 5:
	      wrt1+=gd.writhe[y];
	   CASE 2:
	   case 4:
	      wrt2+=gd.writhe[y];
         } // switch
       } // for

       gd.w_plus[y]=wrt1;
       gd.w_minus[y]=wrt2;
     }

     // done !!


     return gd;
} // end k_link::operator ELGD()

   

knot::knot (u_sh l,comp *pts,u_sh cl,crsg *crs): len(l), ncr(cl)
{

   // l - len of pts array
   // crs - all crossings,
   // cl - their number
   // pts - vertices of the plane curve underlying the knot
   // projection
   // running along the plane curve starting in pts[0].

   // condition: there is no vertex lying on a(n other) line!
   ngon g(l,pts);
   // first construct the plane curve

   // it will be put into `kpts' by adding
   // after each vertex all the crossing pts of the following
   // line with the crossing info read in from 'crs'.

   // first compute coords of all crsgs
   comp nccrd[cl];
   // 
   ccrd=new comp[cl];
   crss=new crsg[cl];
   // copyarray(crs,cl);
   vrt=copyarray(pts,l);

   u_sh y;
   double z;

   for(y=0;y<cl;y++)
   {
     crossing(g[crs[y].above],
	      g[crs[y].above+1],
	      g[crs[y].below],
	      g[crs[y].below+1],
	      z);

	      nccrd[y]=z*(g[crs[y].above+1]-g[crs[y].above])+
			     g[crs[y].above];
   }






   kpts=new knotpt[2*ncr+len]; // len(kpts)=len(g)+2 #crsgs

   u_sh i,n,j,i1=0,i2;
   knotpt kpn;

  // i1- total # of pts filled into kpts
  // i2 - how many crsgs of line j have been put so far into `kpts'
  // j - line to put with all its cross pts into `kpts'
  // y - crsg to check if it is on line j
  // k - # of line found to cross with line j
  // o - total # of crsgs filled into crss

   for(j=0;j<l;j++)
   {
   
     int a;
     sh k;

     i2=0;

     kpts[i1]=knotpt(g[j],0);
     // put next vertex (vertex j) into kpts;
     // then look for crossgs on line starting in vertex j

     // search through array `crs'
     for(y=0;y<cl;y++)
     {
	if(crs[y].above==j) k=crs[y].below+1; else
	if(crs[y].below==j) k=-crs[y].above-1; else continue;
        // lines R #ed here from 1 ...
        // since we need 0 to indicate a knotpt to be a vertex
        // in the `cross' component

	// // if (abs(k)>j) crss[o]=crs[y],ccrd[o++]=nccrd[y];
	// // if crsg passed 1st time, put it into crss';

        kpn=knotpt(nccrd[y],k);
	  // crsg found, put it into kpts



	  // so far put crsgs of line j are ordered incr. by their
	  // distance from g[j].
	  // go through so far put crsgs of line j, beginning @ the end
	  // and shift them making place for `kpn' and finally
	  // putting `kpn' in ordered position.



	  for(sh m=i2;m>=0;m--)
	  {
	    if( norm2(kpts[i1+m]-kpts[i1])<norm2(kpn-kpts[i1]) )
	     { kpts[i1+m+1]=kpn; i2++; break; }
	    else kpts[i1+m+1]=kpts[i1+m];
	  }
     } // loop over y



     i1+=i2+1;

   } // loop over j


    for(u_sh yy=0,p=0,b=0 ; yy<len+2*ncr ; yy++)
    // b - current line #
    // yy - current index in `kpts'
    // p - filling level of `ch'
    {

       sh a,q;
       // q - type of current knotpt
       // a - other line in a crsg

       q=sgn(a=kpts[yy].cross);
       // if (yy==0) TRC(*this);


       // 0 - vertex
       // 1 - overcr.
       // -1 - undercr.

       if(q==0)
       { yy>0 && b++; continue; } // skip vertices, going to next line

       a=abs(a)-1;

       // b -this line #, a - other line #

       if(a>b) { // curr. line b lower than other line a -
		 // crsg passed the 1st time
        
	crss[p]= q<0 ? crsg (a,b) : crsg(b,a);
	// if q<0 a above, b below
	// if q>0 b above, a below

         ccrd[p++]= kpts[yy];
       } // if(a>b)
    }// for yy


}


knot::knot (u_sh l,comp *pts,u_sh cl,char *crstr): len(l), ncr(cl)
{

   // crstr - all crossings running along the plane curve
   // starting in pts[0], given in a string with '+' & '-'
   // cl - their number == strlen(crstr)/2;
   // pts - vertices of the plane curve underlying the knot
   // projection
   // running along the plane curve starting in pts[0].
   // l - len of pts array

   // work analog. to the prev. constructor, but 
   // 1) we comp. all inters. of lines of plane curve
   //    and store them into a self-made `crs' array
   // 2) constr `kpts' as before
   // 3) go through `kpts' and change all crsgs according
   //    to `crstr' (which affects `kpts' and `crss' arrays)

   // WARNING: no consistency check is done for `crstr' (i.e.,
   //          1.crsg may have 2 over- or undercrsg.)


   // condition: there is no vertex lying on a(n other) line!
   ngon g(l,pts);
   // first construct the plane curve

   // it will be put into `kpts' by adding
   // after each vertex all the crossing pts of the following
   // line with the crossing info read in from 'crs'.

   // first compute coords of all crsgs
   comp nccrd[cl];
   // 
   ccrd=new comp[cl];
   crss=new crsg[cl];
   // copyarray(crs,cl);
   vrt=copyarray(pts,l);

   u_sh y,l1,l2;
   double z;

   crsg crs[cl];

   for(l1=0,y=0;l1<l-2;l1++)
   for(l2=l1+2;l2<l;l2++)
   {
     if (abs(crossing(g[l1], g[l1+1], g[l2], g[l2+1], z) )==2
              &&  z>0  &&  z<1)

	      { nccrd[y]=z*(g[l1+1]-g[l1])+g[l1];
		crs[y++]=crsg(l1,l2);
		// here crsg is correct up to swapping l1 & l2
		// temp. set all crsgs so that higher line is below
	      }
   }

   
   PERROR(y!=ncr,"crsg nr not corr, "<<y<<" crsg found")





   kpts=new knotpt[2*ncr+len]; // len(kpts)=len(g)+2 #crsgs

   u_sh i,n,j,i1=0,i2;
   knotpt kpn;

  // i1- total # of pts filled into kpts
  // i2 - how many crsgs of line j have been put so far into `kpts'
  // j - line to put with all its cross pts into `kpts'
  // y - crsg to check if it is on line j
  // k - # of line found to cross with line j
  // o - total # of crsgs filled into crss
  // // mncr - int to check ncr


   for(j=0;j<l;j++)
   {
   
     int a;
     sh k;

     i2=0;

     kpts[i1]=knotpt(g[j],0);
     // put next vertex (vertex j) into kpts;
     // then look for crossgs on line starting in vertex j

     // search through array `crs'
     for(y=0;y<cl;y++)
     {
	if(crs[y].above==j) k=crs[y].below+1; else
	if(crs[y].below==j) k=-crs[y].above-1; else continue;
        // lines R #ed here from 1 ...
        // since we need 0 to indicate a knotpt to be a vertex
        // in the `cross' component

	// // if (abs(k)>j) crss[o]=crs[y],ccrd[o++]=nccrd[y];
	// // if crsg passed 1st time, put it into crss';

        kpn=knotpt(nccrd[y],k);
	  // crsg found, put it into kpts



	  // so far put crsgs of line j are ordered incr. by their
	  // distance from g[j].
	  // go through so far put crsgs of line j, beginning @ the end
	  // and shift them making place for `kpn' and finally
	  // putting `kpn' in ordered position.



	  for(sh m=i2;m>=0;m--)
	  {
	    if( norm2(kpts[i1+m]-kpts[i1])<norm2(kpn-kpts[i1]) )
	     { kpts[i1+m+1]=kpn; i2++; break; }
	    else kpts[i1+m+1]=kpts[i1+m];
	  }

     } // loop over y


     i1+=i2+1;

   } // loop over j


    for(u_sh yy=0,p=0,b=0 ; yy<len+2*ncr ; yy++)
    // b - current line #
    // yy - current index in `kpts'
    // p - filling level of `ch'
    {

       sh a,q,qn;
       // q - type of current knotpt
       // a - other line in a crsg

       q=sgn(a=kpts[yy].cross);
       // if (yy==0) TRC(*this);


       // 0 - vertex
       // 1 - overcr.
       // -1 - undercr.

       if(q==0)
       { yy>0 && b++; continue; } // skip vertices, going to next line

       a=abs(a)-1;

       // b -this line #, a - other line #

       for(qn=0;qn==0;)
       // read the next valid char from `crstr'
       // '+' : next crsg is oversrsg, '-' under-
       { switch(*crstr++)
	 { case '+' : qn=1;
	   CASE '-' : qn=-1;
	   CASE 0 : PERROR(1,"crsg str 2 short"); //error
	 }
       }

       kpts[yy].cross*=(qn/q);
       // set the corr sign

       if(a>b) { // curr. line b lower than other line a -
		 // crsg passed the 1st time
        
	// put the crsg with corr sign into `crss'
	crss[p]= qn<0 ? crsg (a,b) : crsg(b,a);
	// if qn<0 a above, b below
	// if qn>0 b above, a below

         ccrd[p++]= kpts[yy];
       } // if(a>b)
    }// for yy


} // knot::knot


knot::knot(ifstream & i,int fmt_flag=0)
// read in knot from a SnapPea file


{ 

  sh ncmp,nvrt,ncrs, // #comps of link, #vertices, #crsgs
  dum_1,dum_2;		// vars 2 store & skip useless entries

  int re,im;

  if(!fmt_flag) { //	the NEW SnapPea 2.0 format !!


  char buf[80];

  i.getline(buf,80);


  PERROR(string(buf)!="% Link Projection",
  // 1st line must B "% Link Projection"
    "1st line in file must be `% Link Projection'")


  i>>ncmp;

  PERROR(ncmp!=1,"we don't handle links!")
  
  { i>>dum_1>>dum_2; // skip 2 zeroes;

    PERROR(dum_1||dum_2,"there's someth. wrong with the file")

  }


  i>>nvrt;
  
  comp vrt[nvrt];


  for(u_sh y=0;y<nvrt;y++)
  {
     i>>re>>im;
     vrt[y]=comp(re,-im);
     // the vert. comp. in SnapPea files is reversed to ours.
  } // for y

  for(u_sh y=0;y<=2*nvrt;y++)
    i>> dum_1; 
    // skip 2*nvrt+1 entries desc. # & endpts of the edges

  i>>ncrs;

  crsg crss[ncrs];

  for(u_sh y=0;y<ncrs;y++)
  {
    i>> crss[y].below>> crss[y].above ;
  } //for y

  i>> dum_1; // skip final "-1"


  PERROR(~dum_1, // dum_1!=-1
  "there's someth. wrong with the  file")

  *this=knot(nvrt,vrt,ncrs,crss);


  }
  else
  {

  // fmt_flag!=0
  // the xfig format with - & +

  i>>nvrt;
  
  comp vrt[nvrt];


  for(u_sh y=0;y<nvrt;y++)
  {
     i>>re>>im;
     vrt[y]=comp(re,-im);
     // the vert. comp. in SnapPea files is reversed to ours.
  } // 

  i>>ncrs;
  
  string crstr(2*ncrs);

  for(u_sh y=0;y<2*ncrs;y++)
  {
     i>>crstr[y];
     if(crstr[y]!='+' && crstr[y]!='-') y--;
  }

  *this=knot(nvrt,vrt,ncrs,crstr);

  } // end if(fmt_flag)

} // knot::knot(ifstream & i)

k_link::k_link(ifstream & i,int fmt_flag=0)
  // read in a link K+T from a file in 
  // the NEW SnapPea 2.0 format !!

{
  sh ncmp,nvrt,ncrs, // #comps of link, #vertices, #crsgs
  dum_1,dum_2;		// vars 2 store & skip useless entries

  int re,im;

  if(!fmt_flag) {

    char buf[80];
  
    i.getline(buf,80);
  
  
    PERROR(string(buf)!="% Link Projection",
    // 1st line must B "% Link Projection"
      "1st line in file must be `% Link Projection'")
  
  
    i>>ncmp;
  
    PERROR(ncmp!=2,"link has <>2 comp") // our links have two components
  		 // 2nd comp = T
  
  
      i>>dum_1>>dum_2; // skip 2 zeroes = 1st & last vert of K
  
      PERROR(dum_1||dum_2,"#2")
  
    sh vrt_flag=0;
    // is T 1st component?
  
    i>>nvrt>>dum_1>>dum_2;
  
    if(nvrt==1) {
    // 1st comp is the point

    nvrt=dum_2-1;
    vrt_flag=1;
    // set flag
    }
    else
    {
    PERROR(dum_1!=nvrt || dum_2-1 != dum_1,"#3")
    // # vert of K = 1st vert of T
    // dum_1 = last vert of T == 1st vert of T
    // dum_2 = # of all vert = # vert of K +1
    }
    
    comp vrt[nvrt];
    // read in coords of vert (in SnapPea y-coord is in opposite
    // direction)
  
    comp T;
  
 if (vrt_flag)
   { i>>re>>im; T=comp(re,-im); }
   // T's coord come 1st
  
    for(u_sh y=0;y<nvrt;y++)
    {
       i>>re>>im;
       vrt[y]=comp(re,-im);
       // the vert. comp. in SnapPea files is reversed to ours.
    } // for y
  
 if(!vrt_flag)
   { i>>re>>im; T=comp(re,-im); }
    // last vert is T
  
    for(u_sh y=0;y<=2*nvrt;y++)
      i>> dum_1; 
      // skip 2*nvrt+1 entries desc. # & endpts of the edges
  
    // read in crsgs
    i>>ncrs;
  
    crsg crss[ncrs];
  
    for(u_sh y=0;y<ncrs;y++)
    {
      i>> crss[y].below>> crss[y].above ;
      // even if T is 1st, line #ing is not affected

      // if(vrt_flag) { crss[y].below--; crss[y].above--; }

    } //for y
  
    i>> dum_1; // skip final "hot vertex" = -1
  
  
    PERROR(~dum_1,"#4") // dum_1!=-1
  
    *this=k_link(knot(nvrt,vrt,ncrs,crss),T);
  
  
  }
  else
  {

    // fmt_flag!=0
    // the xfig format with - & +
  
    i>>nvrt;
    
    comp vrt[nvrt];
  
  
    for(u_sh y=0;y<nvrt;y++)
    {
       i>>re>>im;
       vrt[y]=comp(re,-im);
       // the vert. comp. in SnapPea files is reversed to ours.
    } // 
  
    i>>re>>im;
    comp t(re,-im);
  
    i>>ncrs;
    
  
    string crstr(2*ncrs);
  
    for(u_sh y=0;y<2*ncrs;y++)
    {
       i>>crstr[y];
       PERROR(i.eof(),"crsg str 2 short"); //error
       if(crstr[y]!='+' && crstr[y]!='-') y--;
    }
  

    *this=k_link(knot(nvrt,vrt,ncrs,crstr),t);


  } // else
}

inline knot flip(const knot k)
{ PSpt xa,xb; bbox(k,xa,xb);
  return k.flip((Im(xa)+Im(xb))/2);
}

inline k_link flip(k_link k)
{ PSpt xa,xb;
  bbox(knot(k),xa,xb);
  k_link u=k.flip((Im(xa)+Im(xb))/2);
  return u;
  // k.flip((Im(xa)+Im(xb))/2);
}


// array for all invs.
// 1st index is link parity
GInv vt[2][34]=
  {
    // lk even (34 inv)
    // stable inv (15), thereof
    {vt31,// 4 sensitive
     vt3,
     vassiliev3,
     vt0,


     vt32,// 11 non-sens
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
      
     // unstable inv (19), all sens.
     vt34,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0

     
    },
    // lk odd (33 inv)
    // stable inv (14), thereof
    {vt0, // 4 sens
     vt3,
     vassiliev3,
     vt0,
     
     vt0, //10 non-sens
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,

     // unstable inv (19), all sens.
     vt33,
     vt34,
     vt35,
     vt0,
     vt3, // #19 =  Fiedler's Vassiliev 3
     vassiliev3, // #20 =  Polyak/Viro's Vassiliev 3
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0,
     vt0


    }
 };

const u_int n_inv[5]={39,40,/* 0 */ 99,27,0},
      n_atoms[3]={462, 112, 462},
// # of known invs per type modulus and linking number & # atoms
// for type in Z, Z2, Z3
      Z_n=1,
      // cons over type in Z ONLY lk<Z_n & lk>=0
      Z_n_inv[1]={22};
      // # of known invs for type in Z, lk=0,...,Z_n-1

inline u_int NUM(int l,int mod)
{
  ret mod>1? n_inv[MOD(l,mod)+(mod*(mod-1))/2-1]:
      ((l<0 || l>=Z_n) ? 0 : Z_n_inv[l]);
}


bool inv_match(sh i,char *s) {
// is inv i contained in list?


if(!s) return true;
// null ptr spec all inv

int nchar,i1,i2;
char c;
sh mflag=0;
// flag is set if prev # was on the left of a '-' sign

while(sscanf(s,"%d%c%n",&i1,&c,&nchar)==2)
{
  switch(c) {
    case ',': 
      if(i==i1||mflag&&i<i1&&i>=i2) return true; mflag=0;
    CASE '-': i2=i1; mflag=1;
  }
  s+=nchar; // skip all scanned chars
}

return false;
}

ofstream log_f; // log file
// ofstream nul=ofstream("/dev/null",ios::out);
int q_mode=0; // q_mode==1 <-> no output
#define OUTP(a) (log_f<<a,q_mode? : (cout<<a,1))



WGT_FNC2(sg2_D,wp*wq*(ipp-ipm-iqp+iqm))
WGT_FNC2(sg2_I,wp*wq*(ipp+ipm+iqp+iqm))
WGT_FNC2(sg2_N,wp*wq*(npp-npm-nqp+nqm))
WGT_FNC2(sg1_2W,wp-wq)
WGT_FNC2(sg2_np,wp*wq*(npp-npm))
WGT_FNC2(sg2_dp,wp*wq*(ipp-ipm))
WGT_FNC2(sg2_ip,wp*wq*(ipp+ipm))
WGT_FNC2(wA111,wp*wq*(nrp+nrm))

#include "x.h"
#include "y.h"

GInv *atomarray[3]={B,A,B};

rat *compute (const ELGD b, u_int l,u_int m=2,int h=1)
{ 
      rat x[n_atoms[m-1]];
      zeroarray(x,n_atoms[m-1]);

      u_sh  p,q,r,t,u,num=NUM(l,m);
	
//	TRC(num);
//	TRC(l);
//	TRC(m);

      // ELGD wi=b;

      GInv *A=atomarray[m-1];

      // if(b.deg<3) return 0;

      for(p=1;p<=b.deg;p++) // chords in GD must 
      for(q=1;q<=b.deg;q++) // be labelled 1,...,degree
      for(r=1;r<=b.deg;r++)
	if(p!=q&&p!=r&&q!=r) //choose chords p,q,r distinct
	{ 
	   t=b.type_mode(p,q,r,m);

	   u=b.conf_mode(p,q,r);

	   FOR(o,n_atoms[m-1])
	   IFOR(A[o].len) // for all terms in the inv.
           {

	     if(
		    (m<2?Ztype_match(b.typ(p),b.typ(q),b.typ(r),t,h) :
		      conf_match(t,(A[o])[i].types)) &&
		    conf_match(u,(A[o])[i].conf) &&
		    (m!=3||o<122||o>141 ||b.cycl_match(p,q,r)) &&
		    (A[o])[i].cf != rat(0)
	       )
		// check if p,q,r have the right types
		// and their conf matches pattern of the summand
		 { 

		 rat k=
		   ((A[o])[i].proc)(
		       b.wr(p),b.wr(q),b.wr(r),
		       b.ip(p),b.ip(q),b.ip(r),
		       b.im(p),b.im(q),b.im(r),
		       b.np(p),b.np(q),b.np(r),
		       b.nm(p),b.nm(q),b.nm(r),
		       b.wp(p),b.wp(q),b.wp(r),
		       b.wm(p),b.wm(q),b.wm(r),
		       b.deg
		       );

		       rat l=(A[o])[i].cf;
		       x[o]+=k*l;

		     }
            }
        }

	// OUTP(endl);
        // FOR(o,n_atoms[m-1])
           // { if(x[o]!=rat(0)) { TRC(o); TRC(x[o]); } }

        if(m==2) {

	   if(l) 
	   { rat oddinvs[]=
   #include"oddinv.h"
   
            ret copyarray(oddinvs,num);
	    // OUTP("invt "<<o+1<<": "<<oddinvs[o]<<"."<<endl);
   
	    }
	    else
	    { rat eveninvs[]=
   #include"eveninv.h"
   
	    ret copyarray(eveninvs,num);
	    // FOR(o,56)
	    // OUTP("invt "<<o+1<<": "<<eveninvs[o]<<"."<<endl);
   
   
	    }
        } 

	if(m==3) {
   
	    if(l==0) {
   
	    rat inv0mod3[]=
	   //  {};
#include "lk0mod3.h"
   
	    ret copyarray(inv0mod3,num);
   
            }  

	    if(l==1) {
	    rat inv1mod3[]=
#include "lk1mod3.h"

	    ret copyarray(inv1mod3,num);
	    }
   
   
	    if(l==2) { rat inv2mod3[]=
	    {};
   
	    ret copyarray(inv2mod3,num);
            } 
	}

	if(m==1) {
	    
	    if(l==0) {
	    rat lkZ_0[]=
#include "lkZ_0.h"

	    ret copyarray(lkZ_0,num);
	    }

	    else
	    {
	    rat empty[]={};
	    ret copyarray(empty,0);
	    }
	}

 }

inline bool mut_prime(u_int d,u_int e)
{
   for(u_int i=2;i<=d && i<=e; i+=(i>2?2:1))
        if( !(d%i) && !(e%i) ) ret false;
   ret true;
}

rat J(const ELGD b,const int h)
{
   u_sh p,q;
   rat s=0;
   int d,e;

   for(p=1;p<=b.deg;p++)
   {
      if(!h) ret 0; 
      if(b.typ(p)%abs(h)) cont;
      d=b.typ(p)/h;
      for(q=1;q<=b.deg;q++)
      {
         if(q==p || b.link_mode(p,q)!=1 || b.typ(q)%abs(h)) cont;
         e=b.typ(q)/h;

         if(d==1 && e==0 || // ((H),0)
            d>0 && e<0 && mut_prime(d,-e) // ((nH),-mH)
           )
         { s+=b.wr(p)*b.wr(q);
	 }
      }
   }
   ret s;
}

rat *allJ(const ELGD b, int &o)
// put into o max(|types|) of b & return array of J(i)(b),
// -o<=i<=o. [ J(i) is 0 esle; J(0) is useless & maybe NOT inv ]
{ o=0;
  IFOR(b.deg) if(abs(b.typ(1+i))>o) o=abs(b.typ(1+i));
  rat *r=new rat[2*o+1];
  for(int y=-o;y<=o;y++)
  {
    r[y+o]=J(b,y);
  }
  ret r;
}
 
u_sh j_mode=0;
// compute J instead of deg 3 invs?

void all_inv(k_link k,int inv_mode =15,u_sh mod=2,int h=1) {
// print all invs on `k'

  int l=k.lk();
  GInv *p;
  if (mod==2) p=vt[MOD(l,2)];

  ERROR(j_mode && l, "try to compute J for non-0 lk")

  // OUTP("lk(K,T)="<<l<<endl);
  if (j_mode) OUTP("invs J"<<endl);
  else OUTP("mod="<<mod<<endl);
  // l=MOD(l,mod);
  // u_sh num=n_inv[l+mod*(mod-1)/2-1];

  // (ELGD)k;

  // exit();
  OUTP("w="<<t_writhe(k)<<endl);

  OUTP("n="<<t_whitind(k)<<endl<<endl);

  // OUTP(endl);

  if (!inv_mode) ret;



  // (ELGD)(k);
  // (ELGD)(-k);

  // k_link k1=k;
  if(!inv_str || mod>2)

  { char *st[5]={"k","-k","flip(k)","!k","flip(!k)"};
    const k_link ks[5]={k,-k,flip(k),!k,flip(!k)};
    // IFOR(5) { TRC(i); TRC(ks[i]); }
    rat *r[5];
    char *s[5];
    sh u=0,ln[5];


    u_sh max_inv=0;
    // max nr of inv for some of the k_links
    int min_nr=-1;
    // -(least # pf inv)


    IFOR(5)
    {
      if (inv_mode & (1<<i))
      {
	s[u]= st[i];
//	TRC(s[u]);
	ln[u]=ks[i].lk(); 
//	TRC(ln[u]);
	ELGD e=ks[i].operator ELGD();
//	TRC(e);
	if(!j_mode)
	{ r[u]=compute(e,MOD(ln[u], mod) , mod,h);
//	  TRC(r[u]);
	  if(max_inv<NUM(ln[u],mod)) max_inv=NUM(ln[u],mod);
	}
	else
	{
	  r[u]=allJ(e,min_nr);
	  max_inv=2*min_nr+1;
	}
	u++;
      }
    }

    OUTP("invt\t");
    IFOR(u) OUTP(s[i]<<"\t");
    OUTP(endl<<"\t");
    IFOR(u) OUTP("lk="<<ln[i]<<"\t");

    OUTP(endl<<endl);

    FOR(o,max_inv)
    { OUTP(form("%3d ",o-min_nr)<<"\t");
      IFOR(u) {
	if(j_mode || o<NUM(ln[i],mod)) { OUTP((r[i])[o]); }
	OUTP("\t");
      }
      OUTP(endl);
    }
    IFOR(u) delete [] r[i];

    OUTP(endl);
  }
  else

  for(u_sh y=0;y<NUM(l,mod);y++)
  { 


    if(!inv_match(y+1,inv_str)) continue;



    OUTP("inv #"<<y+1<<":"<<endl);

    // k=k1;


    rat erg;
// #define AUSG(a) { k_link tk=a; erg=p[y](tk); \
   // OUTP(nme(p[y])<<"(" #a ")="<<erg<<endl); }
#define AUSG(a) { erg=p[y](a); \
   OUTP(nme(p[y])<<"(" #a ")="<<erg<<endl); }


    if (inv_mode & 1) AUSG(k)


    if (inv_mode & 2) AUSG(-k)



    // k_link j=flip(k);

    if (inv_mode & 4) AUSG(flip(k))
    // AUSG(flip(k))


    if (inv_mode & 8) AUSG(!k)
    if (inv_mode & 16) AUSG(flip(!k)) 
      // k_link h1=!k;

      // AUSG(flip(!k)) 
     


    OUTP(endl);

  }
}

/*------------------------------------------------------------ */
#ifdef LINK

class link: public knot {
  u_int *cmpe; // array of comp ends (NOT lengths) in `knot::vrt'
  u_int cmpn; // # of comps
  u_int *tlens; // array of comp ends in `knot::kpts'

public:

  link(u_int b=1): knot(), cmpn(b), cmpe(new u_int[b]), tlens(new u_int[b]) {}
  u_int next(u_int a, u_int s=1,u_int nr=0) const {
    u_int *y[2]={cmpe,tlens};
    u_int *p=y[nr];
    u_int b=a+s;
    IFOR(cmpn) if(p[i]==b) ret i>0?p[i-1]:0;
    ret b;
  }
  u_int tnext(u_int a, u_int s=1) const { ret next(a,s,1); }


  friend u_int x_tnext(const link & l,u_int a) {
    ret l.next(a,1,1); }
  friend u_int x_tprev(const link & l,u_int a) {
    if(a==0) ret l.tlens[0]-1;
    IFOR(l.cmpn-1) if(l.tlens[i]==a) ret l.tlens[i+1]-1;
    ret a-1;
  }

  link(const knot k): knot(k), cmpn(1), cmpe(new u_int[1]),
     tlens(new u_int[1]) { cmpe[0]=k.len; tlens[0]=k.len+2*k.ncr; }

  link(const link &l): knot((knot) l), cmpn(l.cmpn), 
     cmpe(copyarray(l.cmpe,l.cmpn)),
     tlens(copyarray(l.tlens,l.cmpn)) {}
  link(link &l): knot((knot) l), cmpn(l.cmpn), 
     cmpe(copyarray(l.cmpe,l.cmpn)),
     tlens(copyarray(l.tlens,l.cmpn)) {}
  link & oper = (const link &l) {
      len=l.len; ncr=l.ncr; 
      delete [] kpts,vrt,crss,ccrd;
      kpts=copyarray(l.kpts,len+2*ncr); 
      crss=copyarray(l.crss,ncr);
      ccrd=copyarray(l.ccrd,ncr);
      vrt=copyarray(l.vrt,len);
     // ((knot)(*this))=(knot)l;
     // (knot)(*this)=(knot)l;
     delete [] cmpe,tlens;
     cmpn=l.cmpn; cmpe=copyarray(l.cmpe,l.cmpn);
     tlens=copyarray(l.tlens,l.cmpn);
     ret *this;
  }

  ~link() { delete [] cmpe,tlens; }

    double help_writhe(crsg c) const
    { u_sh c_a=c.above, // above & below lines in crsg
	   c_b=c.below; 

      comp l_a = vrt[next(c_a)] - vrt[c_a] ,
	   l_b = vrt[next(c_b)] - vrt[c_b] ;
	   // the vectors of both lines as comp #s
      return Im(normalize(l_b)/normalize(l_a));
    }

  void do_next_vert(u_sh & y, char *str,sh b,ostream & o=cout) const;
  void PS(ostream & o=cout) const;
  void ken(ostream & o=cout,int nr=1) const;

  
  link(ifstream & i,int fmt_flag=0);
  link (u_sh l,comp *pts,u_sh cl,crsg *crs,
     u_int nc, u_int *ec);
  link (u_sh l,comp *pts,u_sh cl,char *crstr,
     u_int nc, u_int *ec);
}; // end class link

void link::do_next_vert(u_sh & y, char *str,sh b,ostream & o=cout) const 

{

      // needed 4 PS() proc

      u_sh // tlen=len+2*ncr,

      y1=tnext(y);

      PSpt x1,x2;
      sh a=kpts[y1].cross;
      // a - other crsg strand in case next knotpt is a crsg
      // b - current crsg strand in case next knotpt is a crsg

      comp dl;
      
      switch(sgn(a))
      {
      // in case next knotpt is a crsg draw it and set `y'
      // to the knotpt after the crsg
	case 1: // overcr
	  o<<PSpt(kpts[y1])<<str; y=tnext(y,2);

        CASE -1: // undercr

          bbox(*this,x1,x2);

          dl=normalize(kpts[y1]-kpts[y],(norm(x2-x1)/PS_crs)*
	    min(3.5,
		1/abs(help_writhe(crsg(abs(a)-1,b)))
	       )
	    );
  // o<<  "/b " << abs(help_writhe(crsg(abs(a)-1,b))) << " def\n";
	    // the thickness of the crossing is 1/100 of the length
	    // of the diagonal of the bounding box divided by
	    // the cos of the angle of the inters. lines

	  o<<PSpt(kpts[y1]-dl)<<str<<PSpt(2*dl)<<"rm";
	  y=tnext(y,2);

	  // in case 1 & -1 we can simply write `y+1' inst. of `y1'
	  // since kpts[0] is always a vertex, so y+1 never == tlen, ...

        CASE 0: // vertex
	  o<<PSpt((kpts[y1]+kpts[y])/2)<<str; y=y1;
	  // ... here of course not ! once y+1 is == tlen
      }

} // do_next_vert


void link::ken(ostream & o=cout,int nr=1) const {
   // write ken format of link to `o' nring the link by `nr'

  o<<form("%2d.%8d:",ncr,nr)<<endl;

  int n,a[ncr];
  u_int m,x;
  // x - knotpt running out of curr crsg for- & backward, until
  //     neighbored crsg reached;
  // m - position of neighbored crsg in `crss'
  // a - array of writhes of crsgs
  // n - other strand of neighbored crsg

  IFOR(ncr) { a[i]=sgn(help_writhe(crss[i])); }
  IFOR(ncr) { 
    
    u_int (*p[2])(const link &,u_int)={x_tnext,x_tprev};
#define P(a,b) p[a](*this,b)

    int b=1,d=0;

    if(a[i]<0) swap(b,d);

    char *z[2]={"dcb","bad"};

    o<<i+1<<"- +"[1+a[i]];


    int nx=member(knotpt(ccrd[i],crss[i].below+1),kpts,2*ncr+len)-1,
    // position of overcrg of crsg i in `kpts'
	mx=member(knotpt(ccrd[i],-crss[i].above-1),kpts,2*ncr+len)-1;
    // position of undercrg of crsg i in `kpts'

    ERROR(nx<0 || mx<0, "nx="<<nx<<",mx="<<mx);




    for(x=P(0,nx);!(n=kpts[x].cross);x=P(0,x)); 

    m=member((comp)kpts[x],ccrd,ncr);
  
     ERROR(m==0, "crsg not found 1")

    o<<m<<z[0][n>0?1:1+a[m-1]];

    for(x=P(b,mx);!(n=kpts[x].cross);x=P(b,x)); 
    m=member((comp)kpts[x],ccrd,ncr);

      ERROR(m==0, "crsg not found 2")

    o<<m<<z[b][n>0?1:1+a[m-1]];

    for(x=P(1,nx);!(n=kpts[x].cross);x=P(1,x));
    m=member((comp)kpts[x],ccrd,ncr);
  
     ERROR(m==0, "crsg not found 3")

    o<<m<<z[1][n>0?1:1+a[m-1]];

    for(x=P(d,mx);!(n=kpts[x].cross);x=P(d,x));
    m=member((comp)kpts[x],ccrd,ncr);

      ERROR(m==0, "crsg not found 4")

    o<<m<<z[d][n>0?1:1+a[m-1]];

    o<<endl;

  }

  o<<endl;
}


void link::PS(ostream & o=cout) const { 
   // write PostScript for drawing the knot
   // smooth vertices using curves from the crossing points
   // to the middlepoints of lines containing no crossing

   // the output of the last coord pair of each drawing operation
   // & the stepping of `y' is done by `do_next_vert'
 

     PSpt xa,xb;
     bbox(*this,xa,xb);
     o<<"%%BoundingBox:"<<xa<<xb<<endl;

     o<<"MyPiCDict begin gs np "<<norm(xb-xa)/300<<" sw"<<endl;
     // width of line is 1/300 of the length of the diagonal
     // of the bounding box

     for(int nr=0;nr<cmpn;nr++) {
     // nr = # of comp drawn

     o<<"%% comp"<<nr+1<<endl;
     u_sh y=(nr>0?tlens[nr-1]:0),y0=y;

     sh b=(nr>0?cmpe[nr-1]:0); // counts the current line

     do_next_vert(y,"m pt",b,o); // let coords of 1st pt on
                                 // stack for arrow

     // y0=y; // pos. to break up the loop, always 1 (if kpts[1] is a vertex)
     // or 2 (if it is a crsg)
     // o<<y;
     comp c=normalize(comp(kpts[y])-comp(kpts[y0]),norm(xb-xa)/PS_ar);
     y0=y; 

     // `y' indicates the next control pt
     // either the PS pen is in the middle of a line without crsg
     // and `y' points to its endpoint or
     // the pen is on a crsg and `y' points to next knotpt
     
     


     
     // c=c/norm(kpts[y0]-kpts[0]);
     // c=c*norm(xb-xa)/30;
    
     o<<" "<<2-2*PS_wgt; // needed by `@C'


      					   // direction to draw
					   // orient. arrow
     // from now on, `kpts[y]' always gives the direction in which
     // the next drawing op. should be done

     loop {
           o<<endl;


	  if(kpts[y].cross)
	    { --y; do_next_vert(y,"l",b,o); }
	    // note that `kpts[0]' is a vertex, so y is never 0 here!
	    else
            {
	      b=next(b);
	      o<<PSpt(kpts[y]);
		 // PSpt(kpts[y]*PS_wgt+(*this)[y-1]*(1-PS_wgt))<<
		 // PSpt(kpts[y]*PS_wgt+(*this)[y+1]*(1-PS_wgt));
	      do_next_vert(y,"@C",b,o);
	      if(y==y0) goto marke;
	    }//if /else


	   }//loop

     marke: // draw arrow
	    o<<" p m pt"<< // 1st pop 2-2PS_wgt & move to 1st pt
		  PSpt(comp(-1,PS_aw)*c)<<
		  "rl m"<<
		  PSpt(comp(-1,-PS_aw)*c)<<
		  "rl"<<endl;
   } // for nr

  o<<"s gr e"<<endl; // and stroke

}//PS()

link::link (u_sh l,comp *pts,u_sh cl,crsg *crs,
     u_int nc, u_int *ec): 
     cmpn(nc), cmpe(copyarray(ec,nc)),
     tlens(new u_int[nc])
{
   len=l;
   ncr=cl;


   // l - len of pts array
   // crs - all crossings,
   // cl - their number
   // pts - vertices of the plane curve underlying the knot
   // projection
   // running along the plane curve starting in pts[0].
   // nc - # of comp
   // ec - list of length (# lines) of comp


   // condition: there is no vertex lying on a(n other) line!
   ngon g(l,pts);
   // first construct the plane curve

   // it will be put into `kpts' by adding
   // after each vertex all the crossing pts of the following
   // line with the crossing info read in from 'crs'.

   // first compute coords of all crsgs
   comp nccrd[cl];
   // 
   ccrd=new comp[cl];
   crss=new crsg[cl];
   // copyarray(crs,cl);
   vrt=copyarray(pts,l);

   u_sh y;
   double z;

   for(y=0;y<cl;y++)
   {
     crossing(g[crs[y].above],
	      g[next(crs[y].above)],
	      g[crs[y].below],
	      g[next(crs[y].below)],
	      z);

	      nccrd[y]=z*(g[next(crs[y].above)]-g[crs[y].above])+
			     g[crs[y].above];
   }






   kpts=new knotpt[2*ncr+len]; // len(kpts)=len(g)+2 #crsgs

   u_sh i,n,j,i1=0,i2,tl=0;
   knotpt kpn;

  // i1- total # of pts filled into kpts
  // i2 - how many crsgs of line j have been put so far into `kpts'
  // j - line to put with all its cross pts into `kpts'
  // y - crsg to check if it is on line j
  // k - # of line found to cross with line j
  // o - total # of crsgs filled into crss
  // tl - # of comp parsed so far (current 1 not incl)

   for(j=0;j<l;j++)
   {
   
     int a;
     sh k;

     i2=0;

     kpts[i1]=knotpt(g[j],0);
     // put next vertex (vertex j) into kpts;
     // then look for crossgs on line starting in vertex j

     // search through array `crs'
     for(y=0;y<cl;y++)
     {
	if(crs[y].above==j) k=crs[y].below+1; else
	if(crs[y].below==j) k=-crs[y].above-1; else continue;
        // lines R #ed here from 1 ...
        // since we need 0 to indicate a knotpt to be a vertex
        // in the `cross' component

	// // if (abs(k)>j) crss[o]=crs[y],ccrd[o++]=nccrd[y];
	// // if crsg passed 1st time, put it into crss';

        kpn=knotpt(nccrd[y],k);
	  // crsg found, put it into kpts



	  // so far put crsgs of line j are ordered incr. by their
	  // distance from g[j].
	  // go through so far put crsgs of line j, beginning @ the end
	  // and shift them making place for `kpn' and finally
	  // putting `kpn' in ordered position.



	  for(sh m=i2;m>=0;m--)
	  {
	    if( norm2(kpts[i1+m]-kpts[i1])<norm2(kpn-kpts[i1]) )
	     { kpts[i1+m+1]=kpn; i2++; break; }
	    else kpts[i1+m+1]=kpts[i1+m];
	  }
     } // loop over y



     i1+=i2+1;

     if(next(j)<j) // j last line on a comp
     { tlens[tl]=(tl==0?i1:i1 /*-tlens[tl-1]*/); tl++; }

   } // loop over j


    for(u_sh yy=0,p=0,b=0 ; yy<len+2*ncr ; yy++)
    // b - current line #
    // yy - current index in `kpts'
    // p - filling level of `ch'
    {

       sh a,q;
       // q - type of current knotpt
       // a - other line in a crsg

       q=sgn(a=kpts[yy].cross);
       // if (yy==0) TRC(*this);


       // 0 - vertex
       // 1 - overcr.
       // -1 - undercr.

       if(q==0)
       { yy>0 && b++; continue; } // skip vertices, going to next line

       a=abs(a)-1;

       // b -this line #, a - other line #

       if(a>b) { // curr. line b lower than other line a -
		 // crsg passed the 1st time
        
	crss[p]= q<0 ? crsg (a,b) : crsg(b,a);
	// if q<0 a above, b below
	// if q>0 b above, a below

         ccrd[p++]= kpts[yy];
       } // if(a>b)
    }// for yy


}

link::link (u_sh l,comp *pts,u_sh cl,char *crstr,
     u_int nc, u_int *ec):
     cmpn(nc), cmpe(copyarray(ec,nc)),
     tlens(new u_int[nc])
{
   len=l,ncr=cl;

   // crstr - all crossings running along the plane curve
   // starting in pts[0], given in a string with '+' & '-'
   // cl - their number == strlen(crstr)/2;
   // pts - vertices of the plane curve underlying the knot
   // projection
   // running along the plane curve starting in pts[0].
   // l - len of pts array

   // work analog. to the prev. constructor, but 
   // 1) we comp. all inters. of lines of plane curve
   //    and store them into a self-made `crs' array
   // 2) constr `kpts' as before
   // 3) go through `kpts' and change all crsgs according
   //    to `crstr' (which affects `kpts' and `crss' arrays)

   // WARNING: no consistency check is done for `crstr' (i.e.,
   //          1.crsg may have 2 over- or undercrsg.)


   // condition: there is no vertex lying on a(n other) line!
   ngon g(l,pts);
   // first construct the plane curve

   // it will be put into `kpts' by adding
   // after each vertex all the crossing pts of the following
   // line with the crossing info read in from 'crs'.

   // first compute coords of all crsgs
   comp nccrd[cl];
   // 
   ccrd=new comp[cl];
   crss=new crsg[cl];
   // copyarray(crs,cl);
   vrt=copyarray(pts,l);

   u_sh y,l1,l2;
   double z;

   crsg crs[cl];

   for(l1=0,y=0;l1<l-2;l1++)
   for(l2=l1+(next(l1)<l1?1:2);l2<l;l2++)
   {
     if (abs(crossing(g[l1], g[next(l1)], g[l2], g[next(l2)], z) )==2
              &&  z>0  &&  z<1)

	      { nccrd[y]=z*(g[next(l1)]-g[l1])+g[l1];
		crs[y++]=crsg(l1,l2);
		// here crsg is correct up to swapping l1 & l2
		// temp. set all crsgs so that higher line is below
	      }
   }

   
   PERROR(y!=ncr,"crsg nr not corr, "<<y<<" crsg found")





   kpts=new knotpt[2*ncr+len]; // len(kpts)=len(g)+2 #crsgs

   u_sh i,n,j,i1=0,i2,tl=0;
   knotpt kpn;

  // i1- total # of pts filled into kpts
  // i2 - how many crsgs of line j have been put so far into `kpts'
  // j - line to put with all its cross pts into `kpts'
  // y - crsg to check if it is on line j
  // k - # of line found to cross with line j
  // o - total # of crsgs filled into crss
  // // mncr - int to check ncr
  // tl - # of comp parsed so far (current 1 not incl)



   for(j=0;j<l;j++)
   {
   
     int a;
     sh k;

     i2=0;

     kpts[i1]=knotpt(g[j],0);
     // put next vertex (vertex j) into kpts;
     // then look for crossgs on line starting in vertex j

     // search through array `crs'
     for(y=0;y<cl;y++)
     {
	if(crs[y].above==j) k=crs[y].below+1; else
	if(crs[y].below==j) k=-crs[y].above-1; else continue;
        // lines R #ed here from 1 ...
        // since we need 0 to indicate a knotpt to be a vertex
        // in the `cross' component

	// // if (abs(k)>j) crss[o]=crs[y],ccrd[o++]=nccrd[y];
	// // if crsg passed 1st time, put it into crss';

        kpn=knotpt(nccrd[y],k);
	  // crsg found, put it into kpts



	  // so far put crsgs of line j are ordered incr. by their
	  // distance from g[j].
	  // go through so far put crsgs of line j, beginning @ the end
	  // and shift them making place for `kpn' and finally
	  // putting `kpn' in ordered position.



	  for(sh m=i2;m>=0;m--)
	  {
	    if( norm2(kpts[i1+m]-kpts[i1])<norm2(kpn-kpts[i1]) )
	     { kpts[i1+m+1]=kpn; i2++; break; }
	    else kpts[i1+m+1]=kpts[i1+m];
	  }

     } // loop over y


     i1+=i2+1;

     if(next(j)<j) // j last line on a comp
     { tlens[tl]=(tl==0?i1:i1 /*-tlens[tl-1]*/); tl++; }

   } // loop over j


    for(u_sh yy=0,p=0,b=0 ; yy<len+2*ncr ; yy++)
    // b - current line #
    // yy - current index in `kpts'
    // p - filling level of `ch'
    {

       sh a,q,qn;
       // q - type of current knotpt
       // a - other line in a crsg

       q=sgn(a=kpts[yy].cross);
       // if (yy==0) TRC(*this);


       // 0 - vertex
       // 1 - overcr.
       // -1 - undercr.

       if(q==0)
       { yy>0 && b++; continue; } // skip vertices, going to next line

       a=abs(a)-1;

       // b -this line #, a - other line #

       for(qn=0;qn==0;)
       // read the next valid char from `crstr'
       // '+' : next crsg is oversrsg, '-' under-
       { switch(*crstr++)
	 { case '+' : qn=1;
	   CASE '-' : qn=-1;
	   CASE 0 : PERROR(1,"crsg str 2 short"); //error
	 }
       }

       kpts[yy].cross*=(qn/q);
       // set the corr sign

       if(a>b) { // curr. line b lower than other line a -
		 // crsg passed the 1st time
        
	// put the crsg with corr sign into `crss'
	crss[p]= qn<0 ? crsg (a,b) : crsg(b,a);
	// if qn<0 a above, b below
	// if qn>0 b above, a below

         ccrd[p++]= kpts[yy];
       } // if(a>b)
    }// for yy


} // link::link


link::link(ifstream & i,int fmt_flag=0)
// read in knot from a SnapPea file

{ 
  cmpe=0;
  tlens=0;
  
  sh ncmp,nvrt,ncrs, // #comps of link, #vertices, #crsgs
  dum_1,dum_2;		// vars 2 store & skip useless entries

  int re,im;


  // ERROR(!fmt_flag,"s apPea 2.0 format not supported 4 links")

  if(!fmt_flag) { // SnapPea 2.0 format

    char buf[80];
  
    i.getline(buf,80);
  
  
    PERROR(string(buf)!="% Link Projection",
    // 1st line must B "% Link Projection"
      "1st line in file must be `% Link Projection'")
  
  
    i>>ncmp;
  
    PERROR(ncmp<1,"#comp<1")
  
    i>>dum_1;

    PERROR(dum_1,"there's someth. wrong with the file\n")
  
    u_int ecmp[ncmp];

    for(sh cr=0;cr<ncmp;ecmp[cr++]=dum_1)
    {

      i>>dum_2;
      PERROR(dum_1!=dum_2, "comp "<<cr+1<<" not closed")
      i>>dum_1;
      PERROR(dum_1-dum_2<3, "comp "<<cr+1<<" has <3 vert")
    }

    comp vrt[nvrt=dum_1];
  
    for(u_sh y=0;y<nvrt;y++)
    {
       i>>re>>im;
       vrt[y]=comp(re,-im);
       // the vert. comp. in SnapPea files is reversed to ours.
    } // for y
  
    for(u_sh y=0;y<=2*nvrt;y++)
      i>> dum_1; 
      // skip 2*nvrt+1 entries desc. # & endpts of the edges
  
    // read in crsgs
    i>>ncrs;
  
    crsg crss[ncrs];
  
    for(u_sh y=0;y<ncrs;y++)
    {
      i>> crss[y].below>> crss[y].above ;
      // even if T is 1st, line #ing is not affected

      // if(vrt_flag) { crss[y].below--; crss[y].above--; }

    } //for y
  
    i>> dum_1; // skip final "hot vertex" = -1
  
  
    PERROR(~dum_1,"#4") // dum_1!=-1
  
    *this=link(nvrt,vrt,ncrs,crss,ncmp,ecmp);
  
  
  }
  else
  {

  // fmt_flag!=0
  // the xfig format with - & +
  u_sh j; // runner var

  i>> cmpn; // # of comp
  PERROR(cmpn<=0,"# of comp<=0")

  cmpe=new u_int[cmpn];

  for(j=0;j<cmpn;j++) {

    i>>cmpe[j];
    // here cmpe[j] == len of comp j+1
    PERROR(cmpe[j]<3,"comp "<<j+1<<" has <3 vert");

    if(j) cmpe[j]+=cmpe[j-1];
    // here cmpe[j] == sum of len of comp <=j+1 as desired

  }

  nvrt=cmpe[j-1]; // # of vert = sum of len of all comp

  
  comp vrt[nvrt];


  for(u_sh y=0;y<nvrt;y++)
  {
     i>>re>>im;
     vrt[y]=comp(re,-im);
     // the vert. comp. in SnapPea files is reversed to ours.
  } // 

  i>>ncrs;
  
  string crstr(2*ncrs);

  for(u_sh y=0;y<2*ncrs;y++)
  {
     i>>crstr[y];
     PERROR(i.eof(),"crsg str 2 short"); //error
     if(crstr[y]!='+' && crstr[y]!='-') y--;
  }


  // *this=
  // link(nvrt,vrt,ncrs,crstr,cmpn,cmpe);

  link a=link(nvrt,vrt,ncrs,crstr,cmpn,cmpe);
  *this=a;

  }


} // link::link(ifstream & i)

#endif

/*------------------------------------------------------------ */

#ifdef TANGLE

class tangle: public knot {
  u_int *cmpe; // array of comp ends (NOT lengths) in `knot::vrt'
  u_int cmpn; // # of comps
  u_int *tlens; // array of comp ends in `knot::kpts'
  bool *open; // are comps open or not?

public:

  tangle(u_int b=1): knot(), cmpn(b), cmpe(new u_int[b]), 
		     tlens(new u_int[b]), open(new bool[b](false)) {}
  u_int next(u_int a, u_int s=1,u_int nr=0) const {
    u_int *y[2]={cmpe,tlens};
    u_int *p=y[nr];
    u_int b=a+s;
    IFOR(cmpn) if(p[i]==b) ret open[i]?a:i>0?p[i-1]:0;
    ret b;
  }
  u_int tnext(u_int a, u_int s=1) const { ret next(a,s,1); }

  tangle(const knot k): knot(k), cmpn(1), cmpe(new u_int[1]),
     tlens(new u_int[1]), open(new bool[1](false))
     { cmpe[0]=k.len; tlens[0]=k.len+2*k.ncr; }

  tangle(const tangle &l): knot((knot) l), cmpn(l.cmpn), 
     cmpe(copyarray(l.cmpe,l.cmpn)),
     open(copyarray(l.open,l.cmpn)),
     tlens(copyarray(l.tlens,l.cmpn)) {}
  tangle(tangle &l): knot((knot) l), cmpn(l.cmpn), 
     cmpe(copyarray(l.cmpe,l.cmpn)),
     open(copyarray(l.open,l.cmpn)),
     tlens(copyarray(l.tlens,l.cmpn)) {}
  
  tangle & oper = (const tangle &l) {
      len=l.len; ncr=l.ncr; 
      delete [] kpts,vrt,crss,ccrd;
      kpts=copyarray(l.kpts,len+2*ncr); 
      crss=copyarray(l.crss,ncr);
      ccrd=copyarray(l.ccrd,ncr);
      vrt=copyarray(l.vrt,len);
     // ((knot)(*this))=(knot)l;
     // (knot)(*this)=(knot)l;
     delete [] cmpe,tlens,open;
     cmpn=l.cmpn; 
     cmpe=copyarray(l.cmpe,l.cmpn);
     tlens=copyarray(l.tlens,l.cmpn);
     open=copyarray(l.open,l.cmpn);
     ret *this;
  }

  ~tangle() { delete [] cmpe,tlens; }

    double help_writhe(crsg c) const
    { u_sh c_a=c.above, // above & below lines in crsg
	   c_b=c.below; 

      comp l_a = vrt[next(c_a)] - vrt[c_a] ,
	   l_b = vrt[next(c_b)] - vrt[c_b] ;
	   // the vectors of both lines as comp #s
      return Im(normalize(l_b)/normalize(l_a));
    }

  void draw_arrow(ostream & o,comp c) const;
  void do_next_vert(u_sh & y, char *str,sh b,ostream & o=cout) const;
  void PS(ostream & o=cout) const;
  
  tangle(ifstream & i,int fmt_flag=0);
  tangle (u_sh l,comp *pts,u_sh cl,crsg *crs,
     u_int nc, u_int *ec, bool *ba);
  tangle (u_sh l,comp *pts,u_sh cl,char *crstr,
     u_int nc, u_int *ec, bool *ba);
}; // end class tangle

void tangle::do_next_vert(u_sh & y, char *str,sh b,ostream & o=cout) const 

{

      // needed 4 PS() proc

      u_sh // tlen=len+2*ncr,

      y1=tnext(y);

      PSpt x1,x2;
      sh a=kpts[y1].cross;
      // a - other crsg strand in case next knotpt is a crsg
      // b - current crsg strand in case next knotpt is a crsg

      comp dl;
      
      switch(sgn(a))
      {
      // in case next knotpt is a crsg draw it and set `y'
      // to the knotpt after the crsg
	case 1: // overcr
	  o<<PSpt(kpts[y1])<<str; y=tnext(y,2);

        CASE -1: // undercr

          bbox(*this,x1,x2);

          dl=normalize(kpts[y1]-kpts[y],(norm(x2-x1)/PS_crs)*
	    min(3.5,
		1/abs(help_writhe(crsg(abs(a)-1,b)))
	       )
	    );
  // o<<  "/b " << abs(help_writhe(crsg(abs(a)-1,b))) << " def\n";
	    // the thickness of the crossing is 1/100 of the length
	    // of the diagonal of the bounding box divided by
	    // the cos of the angle of the inters. lines

	  o<<PSpt(kpts[y1]-dl)<<str<<PSpt(2*dl)<<"rm";
	  y=tnext(y,2);

	  // in case 1 & -1 we can simply write `y+1' inst. of `y1'
	  // since kpts[0] is always a vertex, so y+1 never == tlen, ...

        CASE 0: // vertex
	  o<<PSpt((kpts[y1]+kpts[y])/2)<<str; y=y1;
	  // ... here of course not ! once y+1 is == tlen
      }

} // do_next_vert

void tangle::draw_arrow(ostream & o,comp c) const
{    o<<" m pt"<< 
	PSpt(comp(-1,PS_aw)*c)<<
	"rl m"<<
	PSpt(comp(-1,-PS_aw)*c)<<
	"rl"<<endl;
} 


void tangle::PS(ostream & o=cout) const { 
   // write PostScript for drawing the knot
   // smooth vertices using curves from the crossing points
   // to the middlepoints of lines containing no crossing

   // the output of the last coord pair of each drawing operation
   // & the stepping of `y' is done by `do_next_vert'
 

     PSpt xa,xb;
     bbox(*this,xa,xb);
     o<<"%%BoundingBox:"<<xa<<xb<<endl;

     o<<"MyPiCDict begin gs np "<<norm(xb-xa)/300<<" sw"<<endl;
     // width of line is 1/300 of the length of the diagonal
     // of the bounding box

     for(int nr=0;nr<cmpn;nr++) {
     // nr = # of comp drawn

     o<<"%% comp"<<nr+1<<endl;
     u_sh y=(nr>0?tlens[nr-1]:0),y0=y,yy;

     sh b=(nr>0?cmpe[nr-1]:0); // counts the current line

     if(open[nr]) 
     { o<<PSpt(kpts[y])<<"m"; do_next_vert(y,"l pt",b,o); }
     else
     do_next_vert(y,"m pt",b,o); // let coords of 1st pt on
                                 // stack for arrow

     // y0=y; // pos. to break up the loop, always 1 (if kpts[1] is a vertex)
     // or 2 (if it is a crsg)
     // o<<y;
     comp c=normalize(comp(kpts[y])-comp(kpts[y0]),norm(xb-xa)/PS_ar);
     y0=y; 

     // `y' indicates the next control pt
     // either the PS pen is in the middle of a line without crsg
     // and `y' points to its endpoint or
     // the pen is on a crsg and `y' points to next knotpt
     
     


     
     // c=c/norm(kpts[y0]-kpts[0]);
     // c=c*norm(xb-xa)/30;
    
     o<<" "<<2-2*PS_wgt; // needed by `@C'


      					   // direction to draw
					   // orient. arrow
     // from now on, `kpts[y]' always gives the direction in which
     // the next drawing op. should be done

     loop {
           o<<endl;


	  if(kpts[y].cross)
	    { --y; do_next_vert(y,"l",b,o); }
	    // note that `kpts[0]' is a vertex, so y is never 0 here!
	    else
            { yy=y;
	      b=next(b);
	      o<<PSpt(kpts[y]);
		 // PSpt(kpts[y]*PS_wgt+(*this)[y-1]*(1-PS_wgt))<<
		 // PSpt(kpts[y]*PS_wgt+(*this)[y+1]*(1-PS_wgt));
	      do_next_vert(y,"@C",b,o);
	      if(y==(open[nr]?yy:y0)) goto marke;
	    }//if /else


	   }//loop

     marke: // draw arrow
	    o<<(open[nr]?" p pt 4 2 r":" p");

	       if(arrow_flag) draw_arrow(o,c); else o<<" p p"<<endl;

	       if(open[nr])
	       {
		 draw_arrow(o,
                            normalize(comp(kpts[y])-comp(kpts[y-1]),
				      norm(xb-xa)/PS_ar
				     )
			   );
               }


   } // for nr

  o<<"s gr e"<<endl; // and stroke

}//PS()

tangle::tangle (u_sh l,comp *pts,u_sh cl,crsg *crs,
     u_int nc, u_int *ec, bool *ba): 
     cmpn(nc), cmpe(copyarray(ec,nc)),
     tlens(new u_int[nc])
{
   len=l;
   ncr=cl;


   // l - len of pts array
   // crs - all crossings,
   // cl - their number
   // pts - vertices of the plane curve underlying the knot
   // projection
   // running along the plane curve starting in pts[0].
   // nc - # of comp
   // ec - list of length (# lines) of comp


   // condition: there is no vertex lying on a(n other) line!
   ngon g(l,pts);
   // first construct the plane curve

   // it will be put into `kpts' by adding
   // after each vertex all the crossing pts of the following
   // line with the crossing info read in from 'crs'.

   // first compute coords of all crsgs
   comp nccrd[cl];
   // 
   ccrd=new comp[cl];
   crss=new crsg[cl];
   // copyarray(crs,cl);
   vrt=copyarray(pts,l);
   open=copyarray(ba,nc);

   u_sh y;
   double z;

   for(y=0;y<cl;y++)
   {
     crossing(g[crs[y].above],
	      g[next(crs[y].above)],
	      g[crs[y].below],
	      g[next(crs[y].below)],
	      z);

	      nccrd[y]=z*(g[next(crs[y].above)]-g[crs[y].above])+
			     g[crs[y].above];
   }






   kpts=new knotpt[2*ncr+len]; // len(kpts)=len(g)+2 #crsgs

   u_sh i,n,j,i1=0,i2,tl=0;
   knotpt kpn;

  // i1- total # of pts filled into kpts
  // i2 - how many crsgs of line j have been put so far into `kpts'
  // j - line to put with all its cross pts into `kpts'
  // y - crsg to check if it is on line j
  // k - # of line found to cross with line j
  // o - total # of crsgs filled into crss
  // tl - # of comp parsed so far (current 1 not incl)

   for(j=0;j<l;j++)
   {
   
     int a;
     sh k;

     i2=0;

     kpts[i1]=knotpt(g[j],0);
     // put next vertex (vertex j) into kpts;
     // then look for crossgs on line starting in vertex j

     // search through array `crs'
     for(y=0;y<cl;y++)
     {
	if(crs[y].above==j) k=crs[y].below+1; else
	if(crs[y].below==j) k=-crs[y].above-1; else continue;
        // lines R #ed here from 1 ...
        // since we need 0 to indicate a knotpt to be a vertex
        // in the `cross' component

	// // if (abs(k)>j) crss[o]=crs[y],ccrd[o++]=nccrd[y];
	// // if crsg passed 1st time, put it into crss';

        kpn=knotpt(nccrd[y],k);
	  // crsg found, put it into kpts



	  // so far put crsgs of line j are ordered incr. by their
	  // distance from g[j].
	  // go through so far put crsgs of line j, beginning @ the end
	  // and shift them making place for `kpn' and finally
	  // putting `kpn' in ordered position.



	  for(sh m=i2;m>=0;m--)
	  {
	    if( norm2(kpts[i1+m]-kpts[i1])<norm2(kpn-kpts[i1]) )
	     { kpts[i1+m+1]=kpn; i2++; break; }
	    else kpts[i1+m+1]=kpts[i1+m];
	  }
     } // loop over y



     i1+=i2+1;

     if(next(j)<=j) // j last line on a comp; `=' for open comps
     { tlens[tl]=(tl==0?i1:i1 /*-tlens[tl-1]*/); tl++; }

   } // loop over j


    for(u_sh yy=0,p=0,b=0 ; yy<len+2*ncr ; yy++)
    // b - current line #
    // yy - current index in `kpts'
    // p - filling level of `ch'
    {

       sh a,q;
       // q - type of current knotpt
       // a - other line in a crsg

       q=sgn(a=kpts[yy].cross);
       // if (yy==0) TRC(*this);


       // 0 - vertex
       // 1 - overcr.
       // -1 - undercr.

       if(q==0)
       { yy>0 && b++; continue; } // skip vertices, going to next line

       a=abs(a)-1;

       // b -this line #, a - other line #

       if(a>b) { // curr. line b lower than other line a -
		 // crsg passed the 1st time
        
	crss[p]= q<0 ? crsg (a,b) : crsg(b,a);
	// if q<0 a above, b below
	// if q>0 b above, a below

         ccrd[p++]= kpts[yy];
       } // if(a>b)
    }// for yy


}

tangle::tangle (u_sh l,comp *pts,u_sh cl,char *crstr,
     u_int nc, u_int *ec, bool *ba):
     cmpn(nc), cmpe(copyarray(ec,nc)),
     tlens(new u_int[nc])
{
   len=l,ncr=cl;

   // crstr - all crossings running along the plane curve
   // starting in pts[0], given in a string with '+' & '-'
   // cl - their number == strlen(crstr)/2;
   // pts - vertices of the plane curve underlying the knot
   // projection
   // running along the plane curve starting in pts[0].
   // l - len of pts array

   // work analog. to the prev. constructor, but 
   // 1) we comp. all inters. of lines of plane curve
   //    and store them into a self-made `crs' array
   // 2) constr `kpts' as before
   // 3) go through `kpts' and change all crsgs according
   //    to `crstr' (which affects `kpts' and `crss' arrays)

   // WARNING: no consistency check is done for `crstr' (i.e.,
   //          1.crsg may have 2 over- or undercrsg.)


   // condition: there is no vertex lying on a(n other) line!
   ngon g(l,pts);
   // first construct the plane curve

   // it will be put into `kpts' by adding
   // after each vertex all the crossing pts of the following
   // line with the crossing info read in from 'crs'.

   // first compute coords of all crsgs
   comp nccrd[cl];
   // 
   ccrd=new comp[cl];
   crss=new crsg[cl];
   // copyarray(crs,cl);
   vrt=copyarray(pts,l);
   open=copyarray(ba,nc);

   u_sh y,l1,l2;
   double z;

   crsg crs[cl];

   for(l1=0,y=0;l1<l-2;l1++)
   for(l2=l1+(next(l1)<l1?1:2);l2<l;l2++)
   {
     if (abs(crossing(g[l1], g[next(l1)], g[l2], g[next(l2)], z) )==2
              &&  z>0  &&  z<1)

	      { nccrd[y]=z*(g[next(l1)]-g[l1])+g[l1];
		crs[y++]=crsg(l1,l2);
		// here crsg is correct up to swapping l1 & l2
		// temp. set all crsgs so that higher line is below
	      }
   }

   
   PERROR(y!=ncr,"crsg nr not corr, "<<y<<" crsg found")





   kpts=new knotpt[2*ncr+len]; // len(kpts)=len(g)+2 #crsgs

   u_sh i,n,j,i1=0,i2,tl=0;
   knotpt kpn;

  // i1- total # of pts filled into kpts
  // i2 - how many crsgs of line j have been put so far into `kpts'
  // j - line to put with all its cross pts into `kpts'
  // y - crsg to check if it is on line j
  // k - # of line found to cross with line j
  // o - total # of crsgs filled into crss
  // // mncr - int to check ncr
  // tl - # of comp parsed so far (current 1 not incl)



   for(j=0;j<l;j++)
   {
   
     int a;
     sh k;

     i2=0;

     kpts[i1]=knotpt(g[j],0);
     // put next vertex (vertex j) into kpts;
     // then look for crossgs on line starting in vertex j

     // search through array `crs'
     for(y=0;y<cl;y++)
     {
	if(crs[y].above==j) k=crs[y].below+1; else
	if(crs[y].below==j) k=-crs[y].above-1; else continue;
        // lines R #ed here from 1 ...
        // since we need 0 to indicate a knotpt to be a vertex
        // in the `cross' component

	// // if (abs(k)>j) crss[o]=crs[y],ccrd[o++]=nccrd[y];
	// // if crsg passed 1st time, put it into crss';

        kpn=knotpt(nccrd[y],k);
	  // crsg found, put it into kpts



	  // so far put crsgs of line j are ordered incr. by their
	  // distance from g[j].
	  // go through so far put crsgs of line j, beginning @ the end
	  // and shift them making place for `kpn' and finally
	  // putting `kpn' in ordered position.



	  for(sh m=i2;m>=0;m--)
	  {
	    if( norm2(kpts[i1+m]-kpts[i1])<norm2(kpn-kpts[i1]) )
	     { kpts[i1+m+1]=kpn; i2++; break; }
	    else kpts[i1+m+1]=kpts[i1+m];
	  }

     } // loop over y


     i1+=i2+1;

     if(next(j)<=j) // j last line on a comp; `=' for open comps
     { tlens[tl]=(tl==0?i1:i1 /*-tlens[tl-1]*/); tl++; }

   } // loop over j


    for(u_sh yy=0,p=0,b=0 ; yy<len+2*ncr ; yy++)
    // b - current line #
    // yy - current index in `kpts'
    // p - filling level of `ch'
    {

       sh a,q,qn;
       // q - type of current knotpt
       // a - other line in a crsg

       q=sgn(a=kpts[yy].cross);
       // if (yy==0) TRC(*this);


       // 0 - vertex
       // 1 - overcr.
       // -1 - undercr.

       if(q==0)
       { yy>0 && b++; continue; } // skip vertices, going to next line

       a=abs(a)-1;

       // b -this line #, a - other line #

       for(qn=0;qn==0;)
       // read the next valid char from `crstr'
       // '+' : next crsg is oversrsg, '-' under-
       { switch(*crstr++)
	 { case '+' : qn=1;
	   CASE '-' : qn=-1;
	   CASE 0 : PERROR(1,"crsg str 2 short"); //error
	 }
       }

       kpts[yy].cross*=(qn/q);
       // set the corr sign

       if(a>b) { // curr. line b lower than other line a -
		 // crsg passed the 1st time
        
	// put the crsg with corr sign into `crss'
	crss[p]= qn<0 ? crsg (a,b) : crsg(b,a);
	// if qn<0 a above, b below
	// if qn>0 b above, a below

         ccrd[p++]= kpts[yy];
       } // if(a>b)
    }// for yy


} // tangle::tangle


tangle::tangle(ifstream & i,int fmt_flag=0)
// read in knot from a SnapPea file

{ 
  cmpe=0;
  tlens=0;
  open=0;

  sh ncmp,nvrt,ncrs, // #comps of tangle, #vertices, #crsgs
  dum_1,dum_2;		// vars 2 store & skip useless entries

  int re,im;


  // ERROR(!fmt_flag,"s apPea 2.0 format not supported 4 tangles")

  if(!fmt_flag) { // SnapPea 2.0 format

    char buf[80];
  
    i.getline(buf,80);
  
  
    PERROR(string(buf)!="% Link Projection",
    // 1st line must B "% Link Projection"
      "1st line in file must be `% Link Projection'")
  
  
    i>>ncmp;
  
    PERROR(ncmp<1,"#comp<1")
  
    i>>dum_1;

    PERROR(dum_1,"there's someth. wrong with the file\n")
  
    u_int ecmp[ncmp];
    bool mopn[ncmp];
    int ed=0;

    for(sh cr=0;cr<ncmp;ecmp[cr++]=dum_1)
    {

      i>>dum_2;
      ed+=2*(mopn[cr]=dum_1!=dum_2); 
      i>>dum_1;
      PERROR(!mopn[cr] && dum_1-dum_2<3, "comp "<<cr+1<<" has <3 vert")
      PERROR(mopn[cr] && dum_1!=dum_2+1, "#5")

    }

    comp vrt[nvrt=dum_1];
  
    for(u_sh y=0;y<nvrt;y++)
    {
       i>>re>>im;
       vrt[y]=comp(re,-im);
       // the vert. comp. in SnapPea files is reversed to ours.
    } // for y
  
    // for(u_sh y=0;y<=2*nvrt;y++)
    while(ed++<=2*nvrt)
      i>> dum_1; 
      // skip 2*nvrt+1 entries desc. # & endpts of the edges
  
    // read in crsgs
    i>>ncrs;
  
    crsg crss[ncrs];
  
#define AUG(x) for(u_sh j=0;j<ncmp;j++) if(mopn[j]&&ecmp[j]-1<=x) x++;

    for(u_sh y=0;y<ncrs;y++)
    {
      i>> crss[y].below>> crss[y].above ;
      AUG(crss[y].below)
      AUG(crss[y].above)
      // even if T is 1st, line #ing is not affected

      // if(vrt_flag) { crss[y].below--; crss[y].above--; }

    } //for y
  
    i>> dum_1; // skip final "hot vertex" = -1
  
  
    PERROR(~dum_1,"#4") // dum_1!=-1
  
    *this=tangle(nvrt,vrt,ncrs,crss,ncmp,ecmp,mopn);
  
  
  }
  else
  {

  // fmt_flag!=0
  // the xfig format with - & +
  u_sh j; // runner var

  i>> ncmp; // # of comp
  PERROR(ncmp<=0,"# of comp<=0")

  u_int cmpe[ncmp];
  bool mopn[ncmp];


  int q;
  for(j=0;j<ncmp;j++) {

    i>>q; cmpe[j]=abs(q); mopn[j]=q<0;
    // indicate open comps by -length
    // here cmpe[j] == len of comp j+1
    PERROR(cmpe[j]<3,"comp "<<j+1<<" has <3 vert");

    if(j) cmpe[j]+=cmpe[j-1];
    // here cmpe[j] == sum of len of comp <=j+1 as desired

  }

  nvrt=cmpe[j-1]; // # of vert = sum of len of all comp

  
  comp vrt[nvrt];


  for(u_sh y=0;y<nvrt;y++)
  {
     i>>re>>im;
     vrt[y]=comp(re,-im);
     // the vert. comp. in SnapPea files is reversed to ours.
  } // 

  i>>ncrs;
  
  string crstr(2*ncrs);

  for(u_sh y=0;y<2*ncrs;y++)
  {
     i>>crstr[y];
     PERROR(i.eof(),"crsg str 2 short"); //error
     if(crstr[y]!='+' && crstr[y]!='-') y--;
  }


  // *this=
  // tangle(nvrt,vrt,ncrs,crstr,ncmp,cmpe);

  tangle a=tangle(nvrt,vrt,ncrs,crstr,ncmp,cmpe,mopn);
  *this=a;

  }


} // tangle::tangle(ifstream & i)

#endif

/*------------------------------------------------------------ */

main(int argc,char **argv) {


  
  char **ap=argv;
  int psflag=0,l_mode=0,f_flag=0,mod=2,h=1,K_mode=0,ken_mode=0;


  
#define arg ((string)(*ap))
#define shift (ap++,argc--)
  
  pnm=arg;
  shift;		// save & skip prog name
  
#define USAGE  { cerr<<"usage: "<<pnm<<" [-ps] [ -i <inv#s> ] [ -w <PSwgt> ] "<<endl<<"[ -m <mode> ]  [ -c <diagonal len/width of line interrupt for undercrsg> ]"<<endl<<" [ -a <diagonal len/width of arrow> ] [ -l (to write PS of a link ) ]"<<endl<<" [ -h <hom class for Z type> ] [ -mod [1|2|3] ] [-J] [-K]"<<endl<<" [  [ <SnapPea file> [<Re(T)> <Im(T)>] | -p  {<SnapPea file>} ] "<<endl; \
        exit(-2); }

  if(argc)  { 
  
    int inv_mode=15,
    // the 1st 4 bits indicate whether the action should be done
    // for K,-K,flip(K),!K
    // default:
    //  15 for invt comp (all 4)
    //  1 for PS generation (only K)
       fmt_mode=0;
    // expect SnapPea format
    // fmt_mode!=0 : xfig format

    while(arg[0]=='-') { // parse opts
      int corr_opt=0; // is the opt correct

#define OPT(a) if((arg==a) && (corr_opt=1))

      OPT("-f") { shift; sscanf(arg,"%d",&fmt_mode)||(corr_opt=0); }
      // set the format mode

      OPT("-mod") { shift; sscanf(arg,"%d",&mod) && mod>0
	  ||(corr_opt=0); }

      OPT("-ps") { inv_mode=psflag=1; 
      }
      // print out PS instead of calcul. the invs
      
      OPT("-p") { f_flag=1; 
      }
      // read in mult files (instead of one with T coords optional)

      // print out PS instead of calcul. the invs
      OPT("-m") { shift; sscanf(arg,"%d",&inv_mode)||(corr_opt=0); }
      // set the mode 

      OPT("-h") { shift; sscanf(arg,"%d",&h)||(corr_opt=0); mod=1; }
      // set the homology class H for type in Z invs 

      OPT("-w") { shift; psflag=1; sscanf(arg,"%lf",&PS_wgt)&&
	  PS_wgt>0.5&&PS_wgt<=1.||(corr_opt=0); }
      // set the PS weight
      // 1 = sharp vert, 1/2= smooth vert.

      OPT("-c") { shift; psflag=1; sscanf(arg,"%d",&PS_crs)&&
	  PS_crs>0||(corr_opt=0); }

      OPT("-aw") { shift; psflag=1; sscanf(arg,"%lf",&PS_aw)&&
	  PS_ar>0 && (PS_aw=1/PS_aw) ||(corr_opt=0); }

      OPT("-a") { shift; psflag=1; sscanf(arg,"%d",&PS_ar)&&
	  PS_ar>0||(corr_opt=0); }



      OPT("-i") { shift; inv_str=arg+","; }
      // set the spec. inv #s
      // the comma @ the end is needed by inv_match()
      // arg should B someth like "2,7-9,4,3"

#ifdef TANGLE

      OPT("-l") { l_mode=1; }
      // render PS image of a link

      OPT("-ken") { ken_mode=1; }
      // print out ken format of link #ken_mode

#endif

      OPT("-J") { inv_mode=j_mode=1; }
      // compute invs J(H) of deg 2 for type in Z, lk=0

      OPT("-K") { K_mode=psflag=1; }
      // write PS-file without dot for T

      OPT("-q") { TRC_FLAG=0; q_mode=1; }
      // suppress output on cout and switch off trace

      OPT("-af") { arrow_flag=0; }

      if(!corr_opt) {
	CERR<<"incorrect argument `"<<arg<<"'\n";
	USAGE
      }

      shift;  

    } // while

    // if ( ( inv_mode & 16 ) && psflag ) ap[1]=ap[2]="0",argc=3;
    // bit with valence 16 in `inv_mode' indic not to draw T


   // out = q_mode ? (ostream) ofstream("/dev/null",ios::out) : (ostream) cout;

   while(argc) {

    ifstream is(arg,ios::in);

    if(!is)
    { CERR<<form("couldn't open file `%s'\n",(char *)arg);
      exit(-1);
    }
    
    string fnm(arg);

#ifdef TANGLE

    if(l_mode) {

       ofstream o((char *)(fnm+".eps"),ios::out);
       // const 
       tangle l(is,fmt_mode);
       l.PS(o);
       o.close();
       shift;

    }
    else
    if(ken_mode) {

       // ofstream o((char *)(fnm+".eps"),ios::out);
       // const 
       link l(is,fmt_mode);
       l.ken(cout,ken_mode++);
       // o.close();
       shift;
    }
    else
#endif
    {

    k_link k; // here we will store K+T

    shift;
    // char *yu;
    if (argc&&!f_flag) { // coords of T spec, expect knot in file `fnm'

      int r,c;
      
      if ( argc!=2 || sscanf(arg,"%d",&r) == 0 ||
           (shift,sscanf(arg,"%d",&c) == 0 )
         )
      { USAGE
      }
      
      k=k_link(is,comp(r,c),fmt_mode);
      // note that r,c are the coords of T according to the SnapPea format,
      // not to the internal one (the diff betw both is conjugation)
      // the conversion is done by the constructor
      
      shift;
    }
    
    
    else  // coords of T not spec, expect k_link in file `fnm'
    {
    // yu=strdup(fnm);
      k=k_link(is,fmt_mode);
    }



#define FSTR(a) ((char *)(fnm+a ".eps"),ios::out)
#define WR_PS(a,b) { ofstream i FSTR(a); K_mode ? \
	((knot)(b)).PS(i) : (b).PS(i); i.close(); }

    if(psflag)
    { // all versions to PostScript

      // inv_mode=31;

      if (inv_mode & 1) WR_PS("",k)
      if (inv_mode & 2) WR_PS("_iv",-k)
      if (inv_mode & 4) WR_PS("_fl",flip(k))
      if (inv_mode & 8) WR_PS("_mi",!k)
      if (inv_mode & 16)WR_PS("_fm",flip(!k))

      // exit(0);


    }
    else 
    { 
      log_f.open(fnm+".log",ios::out);
      OUTP("file: "<<fnm<<endl);
      all_inv(k,inv_mode,mod,h);
      log_f.close();
    }
    
    } // else
    is.close();

  } //while
    exit(0);
  
  }

#ifndef TEST
   USAGE // goto marke;
#endif





ifstream yi;

yi.open("9_42.dat",ios::in);

// knot(26,car,9,s).PS();
knot(yi,1).PS();

}
